import java.io.BufferedReader;
import java.util.Vector;

import uk.ac.ox.cs.fdr.*;

public class TraceConstructor
{
	Vector<TraceEvent> constructTrace(Session session, Counterexample counterexample, Context context)
	{
		DebugContext debugContext = new DebugContext(
			(RefinementCounterexample) counterexample, true);
		debugContext.initialise(null);

		//Read the second trace
		Behaviour behaviour = debugContext.rootBehaviours().get(
			debugContext.rootBehaviours().size() - 1);
		Vector<TraceEvent> result = new Vector<TraceEvent>();

		for (int i = 0; i < behaviour.trace().size(); ++i) {
			long event = behaviour.trace().get(i);
			if (event == fdr.TAU) {
				Behaviour tauBehaviour = debugContext.revealTau(behaviour, i);
				if (tauBehaviour == null)
					continue;
				event = tauBehaviour.trace().get(i);
			}
			if (event == fdr.INVALIDEVENT || event == 2)
				continue;
			result.add(TraceEventFactory.makeTraceEvent(
				session.uncompileEvent(event).toString(), context));
		}

		if (behaviour instanceof TraceBehaviour)
		{
			long event = ((TraceBehaviour) behaviour).errorEvent();
			assert event != fdr.INVALIDEVENT;
			assert event != fdr.TAU;
			if (event != 2)
				result.add(TraceEventFactory.makeTraceEvent(
					session.uncompileEvent(event).toString(), context));
		}

		return result;
	}
}
