//### This file created by BYACC 1.8(/Java extension  1.15)
//### Java capabilities added 7 Jan 97, Bob Jamison
//### Updated : 27 Nov 97  -- Bob Jamison, Joe Nieten
//###           01 Jan 98  -- Bob Jamison -- fixed generic semantic constructor
//###           01 Jun 99  -- Bob Jamison -- added Runnable support
//###           06 Aug 00  -- Bob Jamison -- made state variables class-global
//###           03 Jan 01  -- Bob Jamison -- improved flags, tracing
//###           16 May 01  -- Bob Jamison -- added custom stack sizing
//###           04 Mar 02  -- Yuval Oren  -- improved java performance, added options
//###           14 Mar 02  -- Tomas Hurka -- -d support, static initializer workaround
//### Please send bug reports to tom@hukatronic.cz
//### static char yysccsid[] = "@(#)yaccpar	1.8 (Berkeley) 01/20/90";






//#line 2 "parser.y"
  import java.io.*;
  import java.util.*;


//#line 22 "Parser.java"




public class Parser
{

boolean yydebug;        //do I want debug output?
int yynerrs;            //number of errors so far
int yyerrflag;          //was there an error?
int yychar;             //the current working character

//########## MESSAGES ##########
//###############################################################
// method: debug
//###############################################################
void debug(String msg)
{
  if (yydebug)
    System.out.println(msg);
}

//########## STATE STACK ##########
final static int YYSTACKSIZE = 500;  //maximum stack size
int statestk[] = new int[YYSTACKSIZE]; //state stack
int stateptr;
int stateptrmax;                     //highest index of stackptr
int statemax;                        //state when highest index reached
//###############################################################
// methods: state stack push,pop,drop,peek
//###############################################################
final void state_push(int state)
{
  try {
		stateptr++;
		statestk[stateptr]=state;
	 }
	 catch (ArrayIndexOutOfBoundsException e) {
     int oldsize = statestk.length;
     int newsize = oldsize * 2;
     int[] newstack = new int[newsize];
     System.arraycopy(statestk,0,newstack,0,oldsize);
     statestk = newstack;
     statestk[stateptr]=state;
  }
}
final int state_pop()
{
  return statestk[stateptr--];
}
final void state_drop(int cnt)
{
  stateptr -= cnt; 
}
final int state_peek(int relative)
{
  return statestk[stateptr-relative];
}
//###############################################################
// method: init_stacks : allocate and prepare stacks
//###############################################################
final boolean init_stacks()
{
  stateptr = -1;
  val_init();
  return true;
}
//###############################################################
// method: dump_stacks : show n levels of the stacks
//###############################################################
void dump_stacks(int count)
{
int i;
  System.out.println("=index==state====value=     s:"+stateptr+"  v:"+valptr);
  for (i=0;i<count;i++)
    System.out.println(" "+i+"    "+statestk[i]+"      "+valstk[i]);
  System.out.println("======================");
}


//########## SEMANTIC VALUES ##########
//public class ParserVal is defined in ParserVal.java


String   yytext;//user variable to return contextual strings
ParserVal yyval; //used to return semantic vals from action routines
ParserVal yylval;//the 'lval' (result) I got from yylex()
ParserVal valstk[];
int valptr;
//###############################################################
// methods: value stack push,pop,drop,peek.
//###############################################################
void val_init()
{
  valstk=new ParserVal[YYSTACKSIZE];
  yyval=new ParserVal();
  yylval=new ParserVal();
  valptr=-1;
}
void val_push(ParserVal val)
{
  if (valptr>=YYSTACKSIZE)
    return;
  valstk[++valptr]=val;
}
ParserVal val_pop()
{
  if (valptr<0)
    return new ParserVal();
  return valstk[valptr--];
}
void val_drop(int cnt)
{
int ptr;
  ptr=valptr-cnt;
  if (ptr<0)
    return;
  valptr = ptr;
}
ParserVal val_peek(int relative)
{
int ptr;
  ptr=valptr-relative;
  if (ptr<0)
    return new ParserVal();
  return valstk[ptr];
}
final ParserVal dup_yyval(ParserVal val)
{
  ParserVal dup = new ParserVal();
  dup.ival = val.ival;
  dup.dval = val.dval;
  dup.sval = val.sval;
  dup.obj = val.obj;
  return dup;
}
//#### end semantic value section ####
public final static short CSP=257;
public final static short NUM=258;
public final static short NAME=259;
public final static short TRUE=260;
public final static short FALSE=261;
public final static short SKIP=262;
public final static short ITER=263;
public final static short WHILE=264;
public final static short DO=265;
public final static short IF=266;
public final static short THEN=267;
public final static short ASSIGN=268;
public final static short SIG=269;
public final static short ISIG=270;
public final static short ATOMIC=271;
public final static short MIN=272;
public final static short MAX=273;
public final static short NOOP=274;
public final static short GLOBCONST=275;
public final static short FROM=276;
public final static short TO=277;
public final static short PROCESS=278;
public final static short PROGRAM=279;
public final static short SIGNAME=280;
public final static short ISIGNAME=281;
public final static short IVAR=282;
public final static short BVAR=283;
public final static short IAVAR=284;
public final static short BAVAR=285;
public final static short CONST=286;
public final static short INT=287;
public final static short BOOL=288;
public final static short WITH=289;
public final static short WATCHING=290;
public final static short LEAFCOMPRESSED=291;
public final static short HIERARCHCOMPRESSED=292;
public final static short DIRTY=293;
public final static short LOCALIVAR=294;
public final static short LOCALBVAR=295;
public final static short LOCALIAVAR=296;
public final static short LOCALBAVAR=297;
public final static short ASSERT=298;
public final static short IN=299;
public final static short ALWAYS=300;
public final static short NEVER=301;
public final static short OUTOFRANGE=302;
public final static short NOSIGNAL=303;
public final static short ERROR=304;
public final static short VERROR=305;
public final static short CSPASSERT=306;
public final static short PARREADS=307;
public final static short PARWRITES=308;
public final static short SEQREADS=309;
public final static short SEQWRITES=310;
public final static short GENREFINEMENT=311;
public final static short SEQREFINEMENT=312;
public final static short PARREFINEMENT=313;
public final static short OVERSEER=314;
public final static short IFX=315;
public final static short ELSE=316;
public final static short OR=317;
public final static short AND=318;
public final static short GE=319;
public final static short LE=320;
public final static short NEQ=321;
public final static short NEG=322;
public final static short YYERRCODE=256;
final static short yylhs[] = {                           -1,
    0,    0,    1,    1,    1,    1,    1,    1,    4,    4,
    6,    3,    3,    3,    3,    3,    3,    3,   10,   10,
   13,   13,    9,    9,   11,   11,   19,   19,   12,   12,
   20,   20,   20,   14,   14,   21,   21,   15,   15,   18,
   18,   23,   23,   24,   24,   24,   24,   16,   16,   17,
   17,   25,   25,   26,   26,   27,   27,   27,    5,   28,
   28,   28,   28,   30,   30,   29,   29,   32,   32,   31,
   31,   31,   31,   31,   31,   31,   31,   31,   31,   33,
   33,   22,   22,   35,    2,   34,   34,   38,   38,   36,
   36,   40,   40,   40,   40,   40,   40,   40,   39,   39,
   39,   39,   39,   39,   39,   39,   39,   39,   39,   48,
   48,   49,   49,   41,   41,   43,   43,   42,   42,   44,
   44,   51,   52,   53,   54,   47,   47,   37,   37,   55,
   55,   55,   55,   55,   55,   55,   55,   55,   55,   55,
   55,   50,   50,   50,   50,   50,   50,   50,   50,   50,
   45,   45,   45,   45,   45,   45,   45,   45,   45,   45,
   45,   45,   45,   56,   56,   56,   56,   46,   46,   46,
   46,   46,   46,   46,   46,   46,   46,   46,   46,   57,
   57,   57,   57,    7,    7,    7,    7,    7,    7,    7,
   59,   59,   58,   58,   60,   60,   60,   60,    8,    8,
    8,    8,   61,   61,   62,   62,   63,   63,   63,   63,
   63,   63,
};
final static short yylen[] = {                            2,
    0,    2,    1,    2,    1,    1,    1,    2,    1,    0,
    1,    4,    3,    7,    6,    2,    2,    2,    0,    2,
    0,    1,    0,    1,    1,    3,    1,    3,    1,    3,
    1,    3,    3,    1,    3,    1,    5,    1,    3,    3,
    5,    1,    5,    1,    3,    1,    3,    2,    4,    2,
    4,    0,    2,    1,    3,    0,    1,    1,    4,    4,
    5,    3,    9,    1,    3,    0,    1,    1,    3,    1,
    1,    1,    3,    3,    3,    3,    3,    2,    3,    4,
    3,    1,    3,    0,    8,    0,    1,    1,    3,    1,
    3,    1,    2,    3,    4,    6,    4,    6,    1,    2,
    4,    4,    6,    3,    3,    5,    7,    2,    4,    0,
    1,    1,    3,    1,    3,    1,    3,    1,    3,    1,
    3,    1,    1,    1,    1,    0,    3,    0,    4,    1,
    1,    1,    1,    4,    4,    3,    3,    3,    3,    6,
    6,    1,    1,    3,    3,    3,    3,    3,    2,    3,
    2,    3,    3,    3,    3,    3,    3,    3,    3,    3,
    1,    1,    1,    1,    4,    1,    4,    3,    3,    3,
    3,    3,    6,    6,    2,    3,    1,    1,    1,    1,
    4,    1,    4,    5,    5,    7,    4,    4,    4,    4,
    1,    1,    1,    3,    1,    3,    1,    1,    5,    5,
    5,    5,    0,    1,    3,    1,    1,    1,    1,    1,
    4,    4,
};
final static short yydefred[] = {                         0,
   11,    0,    0,    0,    0,   24,    0,    0,    0,    0,
    0,    0,    0,    3,    0,    5,    6,    7,    0,    0,
    0,    0,    0,   16,    0,   17,    0,   18,    0,  192,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    2,    9,    4,    8,    0,    0,   57,   58,    0,   88,
    0,    0,    0,    0,    0,    0,    0,  178,  161,  162,
    0,    0,  180,  164,    0,    0,  177,  182,  166,    0,
    0,    0,    0,    0,    0,    0,  163,  179,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,   13,    0,    0,    0,    0,   59,   84,    0,
    0,   53,    0,    0,    0,   82,   81,    0,    0,    0,
    0,    0,    0,    0,  151,    0,  175,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,  195,    0,  197,  198,    0,    0,
  187,  189,  188,  191,  190,  207,  208,    0,    0,    0,
    0,  206,    0,    0,    0,   20,    0,    0,   12,    0,
    0,   22,    0,    0,    0,    0,   64,    0,    0,   89,
    0,   49,   51,    0,    0,   80,    0,    0,    0,    0,
    0,    0,    0,  160,  176,  184,    0,  152,    0,    0,
    0,    0,    0,    0,    0,    0,  170,  171,  172,  185,
    0,    0,    0,    0,    0,  199,    0,  200,  201,  202,
    0,    0,    0,   32,   33,    0,   30,   72,   71,   70,
    0,    0,    0,    0,    0,    0,   62,    0,    0,    0,
   55,   41,   83,    0,    0,  181,  165,  183,  167,  196,
    0,  194,    0,    0,  205,   28,    0,   26,    0,   15,
    0,   78,    0,   60,    0,    0,    0,    0,    0,    0,
    0,   65,    0,   99,    0,    0,    0,    0,    0,    0,
    0,    0,    0,   90,    0,    0,    0,    0,  186,  211,
  212,    0,   14,    0,    0,    0,   79,    0,    0,   75,
   76,   77,    0,   61,    0,  100,    0,    0,    0,    0,
  108,    0,    0,    0,    0,    0,    0,   85,    0,    0,
  174,  173,    0,    0,    0,   39,    0,    0,    0,  126,
  126,  143,  142,    0,    0,    0,    0,    0,  122,    0,
    0,    0,  123,    0,    0,    0,    0,   91,    0,    0,
    0,    0,   35,   44,   46,    0,    0,  101,    0,    0,
    0,  149,    0,  109,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,   94,  130,  131,    0,
    0,    0,    0,   43,    0,    0,    0,    0,  106,    0,
  150,    0,    0,    0,  146,  147,  148,  124,    0,    0,
   95,  115,  125,    0,    0,   97,  117,    0,    0,    0,
  129,   37,   45,   47,   63,  103,    0,    0,    0,    0,
    0,    0,    0,    0,  136,  137,    0,    0,  107,   96,
  119,   98,  121,  134,  135,    0,    0,    0,    0,  140,
  141,
};
final static short yydgoto[] = {                         12,
   13,   14,   15,   43,   16,   17,   18,   19,   20,   90,
  159,   93,  163,  283,  250,   24,   26,   28,  160,   94,
  284,  108,  251,  346,   54,  102,   49,   98,  223,  168,
  224,  225,   35,   51,  169,  273,  308,   52,  274,  306,
  331,  389,  335,  394,  275,  276,  350,  326,  327,  328,
  332,  336,  390,  395,  372,   77,   78,  139,   36,  140,
  150,  151,  152,
};
final static short yysindex[] = {                      1225,
    0,   26, -232, -219, -187,    0,  -61,   23,   50,   56,
   80,    0, 1225,    0,   64,    0,    0,    0,   64, -223,
  -77, -103,  100,    0,  100,    0,  103,    0,  138,    0,
 1220, 1220,   61, -102,   27, -111,   85,   99,  111,  118,
    0,    0,    0,    0,  211,  -84,    0,    0,  -58,    0,
  221,  222,  -16,  229,  233,   35,  -32,    0,    0,    0,
  235,  241,    0,    0,  178,  208,    0,    0,    0,  220,
  226, 1220,  -35, 1220, -105,  112,    0,    0,  -29,  -37,
   40,   43,   43,  119,  -55,  -55,  -55,  -55,   69,  -83,
  289,   90,    0,  314,  328,   82,  -58,    0,    0,  124,
  334,    0, -232, -219,  346,    0,    0,   84,  -35,  -35,
  -35,  -35,  -35,  -35,    0,  -35,    0,  -17,  -25,  109,
 1220, 1220,  -35,  -35,  -35,  -35,  -35,  -35,  -35,  -35,
  -35,  -35,  -35,  113,    0,  353,    0,    0,  276,  365,
    0,    0,    0,    0,    0,    0,    0,  326,  345,  286,
  381,    0,  318,  323,  330,    0,  384,   90,    0,  403,
  154,    0,  360,  198,  -34,  425,    0,   62,  410,    0,
  -16,    0,    0, -187,  228,    0,  680,  734,  140,  273,
  320,  344,  671,    0,    0,    0,  160,    0,  635,  635,
  635,  635,  635,  635,   97,   97,    0,    0,    0,    0,
  237,  180,  -37,  238,  239,    0,  -55,    0,    0,    0,
  247,  391,  230,    0,    0,  232,    0,    0,    0,    0,
  -34,  -34,  458,  830,  467,  -34,    0,  -58,  257, 1191,
    0,    0,    0,  -35,  -35,    0,    0,    0,    0,    0,
  246,    0,  427,  434,    0,    0,  269,    0,  481,    0,
  493,    0,  711,    0,  -34,  -34,  -34,  -34,  -34,  -34,
  504,    0,  274,    0, 1191, 1220, 1220,  518,  519, 1191,
  527, 1151,  271,    0, -118,  -14,  765,  812,    0,    0,
    0,  507,    0,  525,  510,  232,    0,  300,  300,    0,
    0,    0,  830,    0,  -34,    0, -122, -229,  292,  296,
    0,  -26,  -78,  -70,  522,  453,  456,    0, 1220,  -35,
    0,    0,  523,  269,  163,    0,   67, 1191, 1191,    0,
    0,    0,    0,  -26,  -26,  543,  544,  871,    0,  494,
  531,  549,    0,  509,  548,  568, 1151,    0,  145,  117,
  635,  356,    0,    0,    0,    5,  -34,    0,  299,   -2,
  144,    0,  900,    0,  -26,  -26,  -26,  -26,  -26,  -26,
  359, 1151,  361,  362, 1151,  372,    0,    0,    0,  528,
  550,  -18,    7,    0,  181,  626, 1191,  -26,    0,  -35,
    0,  871,  322,  322,    0,    0,    0,    0,  584,  600,
    0,    0,    0,  587,  603,    0,    0,  -26,  -26,  225,
    0,    0,    0,    0,    0,    0,  871,  978, 1151,  359,
 1151,  362,  409,  440,    0,    0,  561,  562,    0,    0,
    0,    0,    0,    0,    0,  -26,  -26,  489,  506,    0,
    0,
};
final static short yyrindex[] = {                         4,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    4,    0,  231,    0,    0,    0,  231,    0,
  -57,  613,  703,    0,  703,    0,    0,    0,    0,    0,
    0,    0,    0,    0,  343,    0,    0,    0,    0,    0,
    0,    0,    0,    0,  -66,    0,    0,    0,    0,    0,
    0,  619,    0,  696,  920,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,  536,  536,  536,  536,    0,    0,
  757,  569,    0,  963,    0,    0,    0,    0,    0,    0,
  782,    0,    0,    0,  988,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,  539,
    0,    0,    0,    0,    0,    0,    0,  -12,  -10,    0,
  542,    0,    0,    0,    0,    0,  825,  569,    0, 1034,
    0,    0,    0,    0,  629,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,  530,    0,  151,  205,
  287,  341,  422,  476,   15,   86,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,  121,  633,  629,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,  850,    0,
 1042,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0, 1096,    0,    0,    0,    0,    0,    0,    0,
    0,  895,    0, 1088,    0,    0,    0,    9,   75,    0,
    0,    0,  157,    0,    0,    0,    0,    0,    0,    0,
    0,  634,    0,    0,  558,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,  643,  268,    0,    0,
    0,  627,    0,    0,    0,  636,  574,    0,    0,  573,
  617,    0,    0,    0,    0,    0,    0,    0,  642,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    1,
   11,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,  285,  520,  592,    0,    0,    0,    0,    0,  641,
    0,    0,    0,    0,  645,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,  209,    0,    0,    0,
    0,    0,    0,    0,    0,    0,   13,   17,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,
};
final static short yygindex[] = {                       689,
    0,    0,    0,  686,    0,    0,    0,    0,    0,    0,
  513,  555,  570,  392,  421,  631,  632,  563,    0,    0,
    0,  407,    0,    0,  725,  588,    0,  -67,  534,    0,
  -89,    0,  288,    0,    0, -197,    0,    0, -202, -146,
  398,  358,  400,  368,   31,  -31,  449,    0,    0,  267,
    0,    0,    0,    0,    0,    0,    0,  585,  688,    0,
  290,    0,  566,
};
final static int YYTABLESIZE=1535;
static short yytable[];
static { yytable();}
static void yytable(){
yytable = new short[]{                         76,
   76,   97,   56,    1,  116,  222,   92,  158,  107,   73,
  221,  133,  330,  325,  169,  185,  131,  130,  324,  129,
  334,  132,  133,  184,   19,  400,   23,  131,  130,  167,
  129,  209,  132,  210,  123,  127,  124,  319,  379,   25,
   76,  117,  119,  378,  132,  123,  127,  124,  375,   74,
  175,   74,   74,   74,  133,  169,  138,  169,  169,  169,
  139,   75,   79,   45,   46,   22,  374,  296,  402,  305,
   74,   27,  301,  169,  169,  169,  169,  177,  178,  179,
  180,  181,  182,   37,  183,  168,   21,  121,  122,   76,
   76,  189,  190,  191,  192,  193,  194,  195,  196,  197,
  198,  199,  115,  259,  118,  228,  401,  169,  257,  256,
   38,  255,  209,  258,  210,   73,   39,   73,   73,   73,
  348,  349,   42,  227,  176,  132,  168,  175,  168,  168,
  168,  252,  253,  133,  305,  133,   73,  138,  131,  169,
   40,  139,  318,  132,  168,  168,  168,  168,  133,  309,
  159,  187,  188,  131,  130,   50,  129,   53,  132,  305,
  262,   68,  305,   56,   68,  288,  289,  290,  291,  292,
  293,  123,  127,  124,   91,  157,  133,   57,  168,  406,
  329,  131,  130,   80,  129,  229,  132,  380,  333,  378,
  367,  159,   19,  120,  121,  122,   81,   69,  121,  122,
   69,   84,  277,  278,  157,  317,  305,   85,  305,  159,
  168,  121,  122,   47,   48,  391,   29,   30,  396,   95,
   56,   86,   58,  218,  219,  106,  146,  147,  148,  149,
   10,  322,  236,   87,   76,   76,   61,   62,   31,   32,
   88,   33,  135,  136,   34,  157,   63,   89,   65,  127,
   67,  220,  127,  310,  127,   96,   56,  376,   68,  323,
   70,   99,  420,  157,  422,  100,  137,  138,  111,  134,
  101,  169,  103,  169,  109,  159,  104,   76,  341,  169,
  110,  169,  169,  169,  169,   74,  156,  121,  122,  169,
   23,   23,  105,  125,  126,  128,  297,  298,  112,  121,
  122,  169,  169,  169,  125,  126,  128,  169,  112,  133,
  113,  112,  169,  169,  131,  130,  114,  129,  141,  132,
   29,  169,  169,  169,  169,  113,  156,  156,  113,  157,
  169,  169,  169,  169,  169,  169,  259,   82,   83,  340,
  158,  257,  168,  347,  168,  156,  258,  162,  408,  161,
  168,   73,  168,  168,  168,  168,  133,  164,  360,  166,
  168,  131,  130,  358,  129,  237,  132,  165,  359,  142,
  143,  144,  168,  168,  168,  153,  154,  155,  168,  171,
  133,  158,  170,  168,  168,  131,  130,  186,  129,  174,
  132,  200,  168,  168,  168,  168,   29,   30,  201,  158,
  202,  168,  168,  168,  168,  168,  168,  159,  203,  159,
  206,  156,  238,  214,  215,  159,  204,  159,  159,  159,
  159,  154,  344,  345,  207,  159,  368,  369,  370,  371,
  125,  126,  128,  121,  122,  205,  239,  159,  159,  159,
  403,  404,  208,  159,  211,  360,  213,  209,  159,  159,
  358,  357,  216,  356,  210,  359,   91,  159,  159,  159,
  159,  157,  154,  157,  226,  158,  159,  159,  159,  157,
  230,  157,  157,  157,  157,  155,  360,  122,  241,  157,
  154,  358,  357,  247,  356,  233,  359,   10,  157,   10,
  249,  157,  157,  157,  240,  243,  244,  157,  254,   10,
   10,  424,  157,  157,  246,   10,  415,  416,  417,  418,
  260,  157,  157,  157,  157,  263,  155,   10,   10,  280,
  157,  157,  157,   10,  279,  360,  281,  282,   10,  153,
  358,  357,  425,  356,  155,  359,  286,   10,   10,   10,
   10,  285,  360,  156,  294,  156,  154,  358,  357,  295,
  356,  156,  359,  156,  156,  156,  156,  299,  300,  307,
  145,  156,  145,  145,  145,  145,  302,  313,  314,  315,
  153,  320,  105,  156,  156,  156,  321,  338,  339,  156,
  337,  430,  342,  354,  156,  156,  361,  355,  153,  362,
  352,  353,  363,  156,  156,  156,  156,  158,  431,  158,
  155,  364,  156,  156,  156,  158,  365,  158,  158,  158,
  158,  366,  145,  106,  377,  158,  104,  388,  398,  329,
  393,  382,  383,  384,  385,  386,  387,  158,  158,  158,
  333,  105,  144,  158,  144,  144,  144,  144,  158,  158,
  399,  102,  409,  410,  407,  411,  412,  158,  158,  158,
  158,  426,  427,   86,  153,  191,  158,  158,  158,   87,
  203,   21,  259,  193,  413,  414,  204,  257,  256,   66,
  255,  133,  258,   67,  110,  104,  131,  130,  154,  129,
  154,  132,   92,  111,  144,  114,  154,  405,  154,  154,
  154,  154,  428,  429,  116,   48,  154,  105,   93,  118,
  102,   41,   52,  120,   44,  343,  316,  133,  154,  154,
  154,  185,  131,  130,  154,  129,  133,  132,  217,  154,
  154,  131,  130,  234,  129,  248,  132,  212,  154,  154,
  154,  154,  155,  172,  155,  173,  232,  154,  154,  154,
  155,  104,  155,  155,  155,  155,   52,  259,  373,   55,
  155,  287,  257,  256,   48,  255,   31,  258,  231,  261,
  392,   52,  155,  155,  155,  397,  102,  421,  155,  351,
  133,  145,  245,  155,  155,  131,  130,  235,  129,  423,
  132,   54,  155,  155,  155,  155,  153,  242,  153,    0,
    0,  155,  155,  155,  153,    0,  153,  153,  153,  153,
   31,  133,    0,    0,  153,  311,  131,  130,    0,  129,
    0,  132,    0,    0,    0,   31,  153,  153,  153,    0,
    0,    0,  153,    0,   27,   54,    0,  153,  153,  105,
    0,  105,    0,    0,    0,    0,  153,  153,  153,  153,
   54,  105,  105,    0,    0,  153,  153,  105,  133,   42,
    0,    0,  312,  131,  130,    0,  129,    0,  132,  105,
  105,  105,    0,    0,    0,  105,  259,    0,   27,    0,
  105,  257,  256,  104,  255,  104,  258,    0,    0,  105,
  105,  105,  105,   27,    0,  104,  104,    0,  105,    0,
    0,  104,    0,   42,   36,    0,    0,    0,  102,    0,
  102,    0,    0,  104,  104,  104,    0,  360,   42,  104,
  102,  102,  358,  357,  104,  356,  102,  359,    0,   50,
    0,    0,    0,  104,  104,  104,  104,    0,  102,  102,
  102,    0,  104,    0,  102,    0,  360,    0,   36,  102,
  381,  358,  357,    0,  356,    0,  359,    0,  102,  102,
  102,  102,   48,   36,   48,    0,    0,    0,    0,   52,
    0,   52,   29,    0,   48,   48,    0,    0,    0,    0,
   48,   52,   52,    0,    0,    0,    0,   52,   50,    0,
    0,    0,   48,   48,    0,    0,    0,   40,   48,   52,
   52,    0,    0,   48,    0,   52,    0,    0,    0,    0,
   52,    0,   48,   48,   48,   48,    0,    0,    0,   52,
   52,   52,   52,   31,  133,   31,    0,    0,  419,  131,
  130,   29,  129,    0,  132,   31,   31,    0,    0,    0,
    0,   31,    0,   25,    0,    0,    0,    0,   54,    0,
   54,   38,    0,   31,   31,    0,   40,    0,    0,   31,
   54,   54,    0,    0,   31,    0,   54,    0,    0,    0,
    0,    0,    0,   31,   31,   31,   31,    0,   54,   54,
    0,    0,    0,    0,   54,    0,    0,    0,    0,   54,
    0,   27,    0,   27,    0,    0,    0,   34,   54,   54,
   54,   54,   25,   27,   27,  128,    0,    0,    0,   27,
   38,    0,    0,    0,    0,    0,   42,    0,   42,    0,
    0,   27,   27,    0,    0,    0,    0,   27,   42,   42,
    0,    0,   27,    0,   42,    0,    0,    0,    0,    0,
    0,   27,   27,   27,   27,    0,   42,   42,    0,    0,
    0,    0,   42,    0,    0,    0,   34,   42,    0,    0,
    0,   36,    0,   36,    0,    0,   42,   42,   42,   42,
    0,    0,    0,   36,   36,    0,    0,    0,    0,   36,
    0,    0,    0,    0,    0,    0,   50,    0,   50,    0,
    0,   36,   36,   72,    0,    0,    0,   36,   50,   50,
   74,    0,   36,    0,   50,   73,    0,    0,    0,    0,
    0,   36,   36,   36,   36,    0,   50,   50,    0,    0,
    0,    0,   50,    0,    0,    0,    0,   50,    0,   29,
    0,   29,    0,   72,    0,    0,   50,   50,   50,   50,
   74,   29,   29,    0,    0,   73,    0,   29,    0,    0,
    0,    0,    0,    0,   40,    0,   40,    0,    0,   29,
   29,    0,   72,    0,    0,   29,   40,   40,    0,   74,
   29,    0,   40,    0,   73,    0,    0,    0,    0,   29,
   29,   29,   29,    0,   40,   40,    0,    0,    0,    0,
   40,    0,    0,    0,    0,   40,    0,    0,    0,    0,
   25,    0,   25,    0,   40,   40,   40,   40,   38,    0,
   38,    0,   25,   25,    0,    0,    0,    0,   25,    0,
   38,   38,    0,  272,    0,    0,   38,    0,    0,    0,
   25,   25,    0,    0,    0,    0,   25,    0,   38,   38,
    0,   25,    0,    0,   38,    0,    0,    0,    0,   38,
   25,   25,   25,   25,   34,    0,   34,    0,   38,   38,
   38,   38,  128,    0,  128,    0,   34,   34,    0,    0,
    0,    0,   34,    0,  128,  128,    0,    0,    0,    0,
  128,    0,    0,    0,   34,   34,    0,    0,    0,    0,
   34,    0,  128,  128,    0,   34,    0,    0,  128,    0,
    0,    0,    0,  128,   34,   34,   34,   34,    0,    0,
    0,    0,  128,  128,  128,  128,    0,    0,   58,    0,
   59,   60,  264,  265,  266,    0,  267,    0,    0,  268,
  269,  270,   61,   62,    0,    0,    0,    0,  271,    0,
    0,    0,   63,   64,   65,   66,   67,  303,  304,    0,
    0,    0,    0,    0,   68,   69,   70,   71,   58,    0,
   59,   60,  264,  265,  266,    0,  267,    0,    0,  268,
  269,  270,   61,   62,    0,    0,    0,    0,  271,    0,
    0,    0,   63,   64,   65,   66,   67,   58,    0,   59,
   60,    1,    0,    2,   68,   69,   70,   71,    0,    0,
    0,   61,   62,    3,    4,    0,    0,    0,    0,    5,
    0,   63,   64,   65,   66,   67,    0,    0,    0,    0,
    0,    0,    0,   68,   69,   70,   71,    6,    0,    0,
    0,    0,    7,    0,    0,    0,    0,    0,    0,    0,
    0,    8,    9,   10,   11,
};
}
static short yycheck[];
static { yycheck(); }
static void yycheck() {
yycheck = new short[] {                         31,
   32,   60,   60,    0,   40,   40,   91,   91,   41,   45,
   45,   37,   91,   40,    0,   41,   42,   43,   45,   45,
   91,   47,   37,   41,   91,   44,  259,   42,   43,   97,
   45,   44,   47,   44,   60,   61,   62,  267,   41,  259,
   72,   73,   74,   46,   44,   60,   61,   62,   44,   41,
   44,   43,   44,   45,   44,   41,   44,   43,   44,   45,
   44,   31,   32,  287,  288,   40,   62,  265,   62,  272,
   62,  259,  270,   59,   60,   61,   62,  109,  110,  111,
  112,  113,  114,   61,  116,    0,   61,  317,  318,  121,
  122,  123,  124,  125,  126,  127,  128,  129,  130,  131,
  132,  133,   72,   37,   74,   44,  125,   93,   42,   43,
   61,   45,  125,   47,  125,   41,   61,   43,   44,   45,
  318,  319,   59,   62,   41,  125,   41,   44,   43,   44,
   45,  221,  222,   37,  337,  125,   62,  125,   42,  125,
   61,  125,  265,   47,   59,   60,   61,   62,   37,  268,
    0,  121,  122,   42,   43,  259,   45,   58,   47,  362,
  228,   41,  365,   61,   44,  255,  256,  257,  258,  259,
  260,   60,   61,   62,  259,  259,   37,   40,   93,  377,
  259,   42,   43,  123,   45,  124,   47,   44,  259,   46,
  337,   41,  259,  299,  317,  318,  299,   41,  317,  318,
   44,  313,  234,  235,    0,  295,  409,  123,  411,   59,
  125,  317,  318,  291,  292,  362,  278,  279,  365,  278,
  278,  123,  258,  258,  259,  258,  282,  283,  284,  285,
    0,  258,   93,  123,  266,  267,  272,  273,  300,  301,
  123,  303,  280,  281,  306,   41,  282,   37,  284,   41,
  286,  286,   44,  268,   46,  314,  314,  347,  294,  286,
  296,   41,  409,   59,  411,   44,  304,  305,   91,  299,
  287,  257,   44,  259,   40,  125,   44,  309,  310,  265,
   40,  267,  268,  269,  270,  277,    0,  317,  318,  275,
  287,  288,  258,  319,  320,  321,  266,  267,   91,  317,
  318,  287,  288,  289,  319,  320,  321,  293,   41,   37,
   91,   44,  298,  299,   42,   43,   91,   45,  279,   47,
  278,  307,  308,  309,  310,   41,  258,   41,   44,  125,
  316,  317,  318,  319,  320,  321,   37,  311,  312,  309,
    0,   42,  257,  277,  259,   59,   47,  258,  380,   61,
  265,  277,  267,  268,  269,  270,   37,   44,   37,  278,
  275,   42,   43,   42,   45,   93,   47,   40,   47,   82,
   83,   84,  287,  288,  289,   86,   87,   88,  293,   46,
   37,   41,  259,  298,  299,   42,   43,  279,   45,   44,
   47,  279,  307,  308,  309,  310,  278,  279,   46,   59,
  125,  316,  317,  318,  319,  320,  321,  257,   44,  259,
  125,  125,   93,  260,  261,  265,   91,  267,  268,  269,
  270,    0,  260,  261,   44,  275,  282,  283,  284,  285,
  319,  320,  321,  317,  318,   91,   93,  287,  288,  289,
  260,  261,  125,  293,   61,   37,   44,  125,  298,  299,
   42,   43,   93,   45,  125,   47,  259,  307,  308,  309,
  310,  257,   41,  259,   40,  125,  316,  317,  318,  265,
   61,  267,  268,  269,  270,    0,   37,  318,  299,  275,
   59,   42,   43,   93,   45,  258,   47,  257,  259,  259,
  259,  287,  288,  289,  258,  258,  258,  293,   41,  269,
  270,   93,  298,  299,  258,  275,  282,  283,  284,  285,
   44,  307,  308,  309,  310,  259,   41,  287,  288,   93,
  316,  317,  318,  293,  279,   37,   93,  259,  298,    0,
   42,   43,   93,   45,   59,   47,   44,  307,  308,  309,
  310,   61,   37,  257,   41,  259,  125,   42,   43,  276,
   45,  265,   47,  267,  268,  269,  270,   40,   40,  289,
   41,  275,   43,   44,   45,   46,   40,   61,   44,   60,
   41,  280,    0,  287,  288,  289,  281,  125,  123,  293,
   59,   93,   60,   41,  298,  299,   93,   44,   59,   59,
  324,  325,   44,  307,  308,  309,  310,  257,   93,  259,
  125,   93,  316,  317,  318,  265,   59,  267,  268,  269,
  270,   44,   93,  258,  316,  275,    0,  259,   91,  259,
  259,  355,  356,  357,  358,  359,  360,  287,  288,  289,
  259,   59,   41,  293,   43,   44,   45,   46,  298,  299,
   91,    0,   59,   44,  378,   59,   44,  307,  308,  309,
  310,   91,   91,   41,  125,  313,  316,  317,  318,   41,
  125,   93,   37,  125,  398,  399,  125,   42,   43,   41,
   45,   37,   47,   41,   41,   59,   42,   43,  257,   45,
  259,   47,  125,   41,   93,   59,  265,   62,  267,  268,
  269,  270,  426,  427,   59,    0,  275,  125,  125,   59,
   59,   13,    0,   59,   19,  314,  286,   37,  287,  288,
  289,   41,   42,   43,  293,   45,   37,   47,  164,  298,
  299,   42,   43,   44,   45,  213,   47,  158,  307,  308,
  309,  310,  257,  103,  259,  104,  174,  316,  317,  318,
  265,  125,  267,  268,  269,  270,   44,   37,  342,   25,
  275,   41,   42,   43,   59,   45,    0,   47,  171,  226,
  363,   59,  287,  288,  289,  366,  125,  410,  293,  321,
   37,   84,  207,  298,  299,   42,   43,   44,   45,  412,
   47,    0,  307,  308,  309,  310,  257,  203,  259,   -1,
   -1,  316,  317,  318,  265,   -1,  267,  268,  269,  270,
   44,   37,   -1,   -1,  275,   41,   42,   43,   -1,   45,
   -1,   47,   -1,   -1,   -1,   59,  287,  288,  289,   -1,
   -1,   -1,  293,   -1,    0,   44,   -1,  298,  299,  257,
   -1,  259,   -1,   -1,   -1,   -1,  307,  308,  309,  310,
   59,  269,  270,   -1,   -1,  316,  317,  275,   37,    0,
   -1,   -1,   41,   42,   43,   -1,   45,   -1,   47,  287,
  288,  289,   -1,   -1,   -1,  293,   37,   -1,   44,   -1,
  298,   42,   43,  257,   45,  259,   47,   -1,   -1,  307,
  308,  309,  310,   59,   -1,  269,  270,   -1,  316,   -1,
   -1,  275,   -1,   44,    0,   -1,   -1,   -1,  257,   -1,
  259,   -1,   -1,  287,  288,  289,   -1,   37,   59,  293,
  269,  270,   42,   43,  298,   45,  275,   47,   -1,    0,
   -1,   -1,   -1,  307,  308,  309,  310,   -1,  287,  288,
  289,   -1,  316,   -1,  293,   -1,   37,   -1,   44,  298,
   41,   42,   43,   -1,   45,   -1,   47,   -1,  307,  308,
  309,  310,  257,   59,  259,   -1,   -1,   -1,   -1,  257,
   -1,  259,    0,   -1,  269,  270,   -1,   -1,   -1,   -1,
  275,  269,  270,   -1,   -1,   -1,   -1,  275,   59,   -1,
   -1,   -1,  287,  288,   -1,   -1,   -1,    0,  293,  287,
  288,   -1,   -1,  298,   -1,  293,   -1,   -1,   -1,   -1,
  298,   -1,  307,  308,  309,  310,   -1,   -1,   -1,  307,
  308,  309,  310,  257,   37,  259,   -1,   -1,   41,   42,
   43,   59,   45,   -1,   47,  269,  270,   -1,   -1,   -1,
   -1,  275,   -1,    0,   -1,   -1,   -1,   -1,  257,   -1,
  259,    0,   -1,  287,  288,   -1,   59,   -1,   -1,  293,
  269,  270,   -1,   -1,  298,   -1,  275,   -1,   -1,   -1,
   -1,   -1,   -1,  307,  308,  309,  310,   -1,  287,  288,
   -1,   -1,   -1,   -1,  293,   -1,   -1,   -1,   -1,  298,
   -1,  257,   -1,  259,   -1,   -1,   -1,    0,  307,  308,
  309,  310,   59,  269,  270,    0,   -1,   -1,   -1,  275,
   59,   -1,   -1,   -1,   -1,   -1,  257,   -1,  259,   -1,
   -1,  287,  288,   -1,   -1,   -1,   -1,  293,  269,  270,
   -1,   -1,  298,   -1,  275,   -1,   -1,   -1,   -1,   -1,
   -1,  307,  308,  309,  310,   -1,  287,  288,   -1,   -1,
   -1,   -1,  293,   -1,   -1,   -1,   59,  298,   -1,   -1,
   -1,  257,   -1,  259,   -1,   -1,  307,  308,  309,  310,
   -1,   -1,   -1,  269,  270,   -1,   -1,   -1,   -1,  275,
   -1,   -1,   -1,   -1,   -1,   -1,  257,   -1,  259,   -1,
   -1,  287,  288,   33,   -1,   -1,   -1,  293,  269,  270,
   40,   -1,  298,   -1,  275,   45,   -1,   -1,   -1,   -1,
   -1,  307,  308,  309,  310,   -1,  287,  288,   -1,   -1,
   -1,   -1,  293,   -1,   -1,   -1,   -1,  298,   -1,  257,
   -1,  259,   -1,   33,   -1,   -1,  307,  308,  309,  310,
   40,  269,  270,   -1,   -1,   45,   -1,  275,   -1,   -1,
   -1,   -1,   -1,   -1,  257,   -1,  259,   -1,   -1,  287,
  288,   -1,   33,   -1,   -1,  293,  269,  270,   -1,   40,
  298,   -1,  275,   -1,   45,   -1,   -1,   -1,   -1,  307,
  308,  309,  310,   -1,  287,  288,   -1,   -1,   -1,   -1,
  293,   -1,   -1,   -1,   -1,  298,   -1,   -1,   -1,   -1,
  257,   -1,  259,   -1,  307,  308,  309,  310,  257,   -1,
  259,   -1,  269,  270,   -1,   -1,   -1,   -1,  275,   -1,
  269,  270,   -1,  123,   -1,   -1,  275,   -1,   -1,   -1,
  287,  288,   -1,   -1,   -1,   -1,  293,   -1,  287,  288,
   -1,  298,   -1,   -1,  293,   -1,   -1,   -1,   -1,  298,
  307,  308,  309,  310,  257,   -1,  259,   -1,  307,  308,
  309,  310,  257,   -1,  259,   -1,  269,  270,   -1,   -1,
   -1,   -1,  275,   -1,  269,  270,   -1,   -1,   -1,   -1,
  275,   -1,   -1,   -1,  287,  288,   -1,   -1,   -1,   -1,
  293,   -1,  287,  288,   -1,  298,   -1,   -1,  293,   -1,
   -1,   -1,   -1,  298,  307,  308,  309,  310,   -1,   -1,
   -1,   -1,  307,  308,  309,  310,   -1,   -1,  258,   -1,
  260,  261,  262,  263,  264,   -1,  266,   -1,   -1,  269,
  270,  271,  272,  273,   -1,   -1,   -1,   -1,  278,   -1,
   -1,   -1,  282,  283,  284,  285,  286,  287,  288,   -1,
   -1,   -1,   -1,   -1,  294,  295,  296,  297,  258,   -1,
  260,  261,  262,  263,  264,   -1,  266,   -1,   -1,  269,
  270,  271,  272,  273,   -1,   -1,   -1,   -1,  278,   -1,
   -1,   -1,  282,  283,  284,  285,  286,  258,   -1,  260,
  261,  257,   -1,  259,  294,  295,  296,  297,   -1,   -1,
   -1,  272,  273,  269,  270,   -1,   -1,   -1,   -1,  275,
   -1,  282,  283,  284,  285,  286,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,  294,  295,  296,  297,  293,   -1,   -1,
   -1,   -1,  298,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,  307,  308,  309,  310,
};
}
final static short YYFINAL=12;
final static short YYMAXTOKEN=322;
final static String yyname[] = {
"end-of-file",null,null,null,null,null,null,null,null,null,null,null,null,null,
null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,
null,null,null,"'!'",null,null,null,"'%'",null,null,"'('","')'","'*'","'+'",
"','","'-'","'.'","'/'",null,null,null,null,null,null,null,null,null,null,"':'",
"';'","'<'","'='","'>'",null,null,null,null,null,null,null,null,null,null,null,
null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,
null,"'['",null,"']'",null,null,null,null,null,null,null,null,null,null,null,
null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,
null,null,"'{'","'|'","'}'",null,null,null,null,null,null,null,null,null,null,
null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,
null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,
null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,
null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,
null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,
null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,
null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,
null,null,null,null,null,null,null,null,null,"CSP","NUM","NAME","TRUE","FALSE",
"SKIP","ITER","WHILE","DO","IF","THEN","ASSIGN","SIG","ISIG","ATOMIC","MIN",
"MAX","NOOP","GLOBCONST","FROM","TO","PROCESS","PROGRAM","SIGNAME","ISIGNAME",
"IVAR","BVAR","IAVAR","BAVAR","CONST","INT","BOOL","WITH","WATCHING",
"LEAFCOMPRESSED","HIERARCHCOMPRESSED","DIRTY","LOCALIVAR","LOCALBVAR",
"LOCALIAVAR","LOCALBAVAR","ASSERT","IN","ALWAYS","NEVER","OUTOFRANGE",
"NOSIGNAL","ERROR","VERROR","CSPASSERT","PARREADS","PARWRITES","SEQREADS",
"SEQWRITES","GENREFINEMENT","SEQREFINEMENT","PARREFINEMENT","OVERSEER","IFX",
"ELSE","OR","AND","GE","LE","NEQ","NEG",
};
final static String yyrule[] = {
"$accept : Input",
"Input :",
"Input : Stmt Input",
"Stmt : Process",
"Stmt : Declaration MaybeSemiColon",
"Stmt : Program",
"Stmt : CSPStmt",
"Stmt : Assertion",
"Stmt : RefDeclaration MaybeSemiColon",
"MaybeSemiColon : ';'",
"MaybeSemiColon :",
"CSPStmt : CSP",
"Declaration : DirtyDeclaration INT SizeDeclaration INameList",
"Declaration : DirtyDeclaration BOOL BNameList",
"Declaration : DirtyDeclaration INT SizeDeclaration '[' ArraySizeDeclaration ']' IANameList",
"Declaration : DirtyDeclaration BOOL '[' ArraySizeDeclaration ']' BANameList",
"Declaration : SIG SigNameList",
"Declaration : ISIG ISigNameList",
"Declaration : GLOBCONST GlobConstList",
"SizeDeclaration :",
"SizeDeclaration : '%' NUM",
"ArraySizeDeclaration :",
"ArraySizeDeclaration : NUM",
"DirtyDeclaration :",
"DirtyDeclaration : DIRTY",
"INameList : IName",
"INameList : IName ',' INameList",
"IName : NAME",
"IName : NAME '=' NUM",
"BNameList : BName",
"BNameList : BName ',' BNameList",
"BName : NAME",
"BName : NAME '=' TRUE",
"BName : NAME '=' FALSE",
"IANameList : IAName",
"IANameList : IAName ',' IANameList",
"IAName : NAME",
"IAName : NAME '=' '<' NonEmptyNumList '>'",
"BANameList : BAName",
"BANameList : BAName ',' BANameList",
"GlobConstList : NAME '=' NUM",
"GlobConstList : NAME '=' NUM ',' GlobConstList",
"BAName : NAME",
"BAName : NAME '=' '<' NonEmptyBoolList '>'",
"NonEmptyBoolList : TRUE",
"NonEmptyBoolList : NonEmptyBoolList ',' TRUE",
"NonEmptyBoolList : FALSE",
"NonEmptyBoolList : NonEmptyBoolList ',' FALSE",
"SigNameList : NAME SigType",
"SigNameList : NAME SigType ',' SigNameList",
"ISigNameList : NAME SigType",
"ISigNameList : NAME SigType ',' ISigNameList",
"SigType :",
"SigType : ':' SigTypeAux",
"SigTypeAux : INT",
"SigTypeAux : INT '.' SigTypeAux",
"CompilationCommand :",
"CompilationCommand : LEAFCOMPRESSED",
"CompilationCommand : HIERARCHCOMPRESSED",
"Program : NAME '=' CompilationCommand CmdStruct",
"CmdStruct : PROCESS '(' ParameterList ')'",
"CmdStruct : OVERSEER PROCESS '(' ParameterList ')'",
"CmdStruct : '<' CmdStructList '>'",
"CmdStruct : '<' CmdStructList '|' NAME FROM Parameter TO Parameter '>'",
"CmdStructList : CmdStruct",
"CmdStructList : CmdStructList ',' CmdStruct",
"ParameterList :",
"ParameterList : NonEmptyParameterList",
"NonEmptyParameterList : Parameter",
"NonEmptyParameterList : NonEmptyParameterList ',' Parameter",
"Parameter : CONST",
"Parameter : NAME",
"Parameter : NUM",
"Parameter : Parameter '+' Parameter",
"Parameter : Parameter '-' Parameter",
"Parameter : Parameter '*' Parameter",
"Parameter : Parameter '/' Parameter",
"Parameter : Parameter '%' Parameter",
"Parameter : '-' Parameter",
"Parameter : '(' Parameter ')'",
"Proc : PROCESS '(' NonEmptyNumList ')'",
"Proc : PROCESS '(' ')'",
"NonEmptyNumList : NUM",
"NonEmptyNumList : NonEmptyNumList ',' NUM",
"$$1 :",
"Process : NAME '(' ArgList ')' $$1 '=' Prog AssignedVariables",
"ArgList :",
"ArgList : NonEmptyArgList",
"NonEmptyArgList : NAME",
"NonEmptyArgList : NonEmptyArgList ',' NAME",
"Prog : Cmd",
"Prog : '{' Cmds '}'",
"Cmds : Cmd",
"Cmds : Cmd ';'",
"Cmds : Cmd ';' Cmds",
"Cmds : INT LocalINameList ';' Cmds",
"Cmds : INT '[' ']' LocalIANameList ';' Cmds",
"Cmds : BOOL LocalBNameList ';' Cmds",
"Cmds : BOOL '[' ']' LocalBANameList ';' Cmds",
"Cmd : SKIP",
"Cmd : ITER Prog",
"Cmd : WHILE BExpr DO Prog",
"Cmd : IF BExpr THEN Prog",
"Cmd : IF BExpr THEN Prog ELSE Prog",
"Cmd : IExpr ASSIGN IExpr",
"Cmd : BExpr ASSIGN BExpr",
"Cmd : SIG '(' SIGNAME Indices ')'",
"Cmd : ISIG '(' ISIGNAME Indices ',' IExpr ')'",
"Cmd : ATOMIC Prog",
"Cmd : PROCESS '(' IConstList ')'",
"IConstList :",
"IConstList : NonEmptyIConstList",
"NonEmptyIConstList : IConst",
"NonEmptyIConstList : NonEmptyIConstList ',' IConst",
"LocalINameList : LocalIName",
"LocalINameList : LocalIName ',' LocalINameList",
"LocalBNameList : LocalBName",
"LocalBNameList : LocalBName ',' LocalBNameList",
"LocalIANameList : LocalIAName",
"LocalIANameList : LocalIAName ',' LocalIANameList",
"LocalBANameList : LocalBAName",
"LocalBANameList : LocalBAName ',' LocalBANameList",
"LocalIName : NAME",
"LocalBName : NAME",
"LocalIAName : NAME",
"LocalBAName : NAME",
"Indices :",
"Indices : Indices '.' IConst",
"AssignedVariables :",
"AssignedVariables : WITH '{' AssignedVariableList '}'",
"AssignedVariableList : IVAR",
"AssignedVariableList : BVAR",
"AssignedVariableList : IAVAR",
"AssignedVariableList : BAVAR",
"AssignedVariableList : IAVAR '[' IConst ']'",
"AssignedVariableList : BAVAR '[' IConst ']'",
"AssignedVariableList : AssignedVariableList ',' IVAR",
"AssignedVariableList : AssignedVariableList ',' BVAR",
"AssignedVariableList : AssignedVariableList ',' IAVAR",
"AssignedVariableList : AssignedVariableList ',' BAVAR",
"AssignedVariableList : AssignedVariableList ',' IAVAR '[' IConst ']'",
"AssignedVariableList : AssignedVariableList ',' BAVAR '[' IConst ']'",
"IConst : CONST",
"IConst : NUM",
"IConst : IConst '+' IConst",
"IConst : IConst '-' IConst",
"IConst : IConst '*' IConst",
"IConst : IConst '/' IConst",
"IConst : IConst '%' IConst",
"IConst : '-' IConst",
"IConst : '(' IConst ')'",
"BExpr : '!' BExpr",
"BExpr : BExpr AND BExpr",
"BExpr : BExpr OR BExpr",
"BExpr : IExpr '=' IExpr",
"BExpr : IExpr NEQ IExpr",
"BExpr : IExpr GE IExpr",
"BExpr : IExpr '>' IExpr",
"BExpr : IExpr LE IExpr",
"BExpr : IExpr '<' IExpr",
"BExpr : '(' BExpr ')'",
"BExpr : TRUE",
"BExpr : FALSE",
"BExpr : BVar",
"BVar : BVAR",
"BVar : BAVAR '[' IExpr ']'",
"BVar : LOCALBVAR",
"BVar : LOCALBAVAR '[' IExpr ']'",
"IExpr : IExpr '+' IExpr",
"IExpr : IExpr '-' IExpr",
"IExpr : IExpr '*' IExpr",
"IExpr : IExpr '/' IExpr",
"IExpr : IExpr '%' IExpr",
"IExpr : MAX '(' IExpr ',' IExpr ')'",
"IExpr : MIN '(' IExpr ',' IExpr ')'",
"IExpr : '-' IExpr",
"IExpr : '(' IExpr ')'",
"IExpr : CONST",
"IExpr : NUM",
"IExpr : IVar",
"IVar : IVAR",
"IVar : IAVAR '[' IExpr ']'",
"IVar : LOCALIVAR",
"IVar : LOCALIAVAR '[' IExpr ']'",
"Assertion : ASSERT ALWAYS BExpr IN PROGRAM",
"Assertion : ASSERT NEVER BExpr IN PROGRAM",
"Assertion : ASSERT NOSIGNAL '{' SignalList '}' IN PROGRAM",
"Assertion : ASSERT CSPASSERT IN PROGRAM",
"Assertion : ASSERT Proc SEQREFINEMENT Proc",
"Assertion : ASSERT Proc GENREFINEMENT Proc",
"Assertion : ASSERT ParRefTerm PARREFINEMENT ParRefTerm",
"ParRefTerm : Proc",
"ParRefTerm : PROGRAM",
"SignalList : Signal",
"SignalList : Signal ',' SignalList",
"Signal : SIGNAME",
"Signal : ISIGNAME '.' NUM",
"Signal : ERROR",
"Signal : VERROR",
"RefDeclaration : PARREADS '=' '{' VarNameList '}'",
"RefDeclaration : PARWRITES '=' '{' VarNameList '}'",
"RefDeclaration : SEQREADS '=' '{' VarNameList '}'",
"RefDeclaration : SEQWRITES '=' '{' VarNameList '}'",
"VarNameList :",
"VarNameList : NonEmptyVarNameList",
"NonEmptyVarNameList : NonEmptyVarNameList ',' VarName",
"NonEmptyVarNameList : VarName",
"VarName : IVAR",
"VarName : BVAR",
"VarName : IAVAR",
"VarName : BAVAR",
"VarName : IAVAR '[' NUM ']'",
"VarName : BAVAR '[' NUM ']'",
};

//#line 596 "parser.y"
  
  

  private Yylex lexer;

  private Compiler compiler;

  private String currentProcess;

  public Compiler getCompiler()
  {
	yyparse();
	compiler.generateLocalVarNames();
	return compiler;		
  }

  private int yylex (){
    int yyl_return = -1;
    try{
      yylval = new ParserVal(0);
      yyl_return = lexer.yylex();

    }
    catch(IOException e){yyerror(e.getMessage());}
    return yyl_return;
  }


  public void yyerror (String error) {
    throw new ParserException("Error Near " + lexer.location() + ": " + error);
  }


  public Parser(Reader r) {
    compiler = new Compiler();
    lexer = new Yylex(r, this, compiler.context);
  }

	void declareContentSize( Vector<String> names, int size)
	{
		for (String name : names)
		{
			compiler.context.setContentSize(name,size);
		}
	}
	void declareArrayContentSize( Vector<String> names, int size)
	{
		for (String name : names)
		{
			compiler.context.setArrayContentSize(name,size);
		}
	}

	void declareArrayIndexSize( Vector<String> names, int size)
	{
		for (String name : names)
		{
			compiler.context.setArrayIndexSize(name,size);
		}
	}
	void declareDirty( Vector<String> names)
	{
		
		for (String name : names)
		{
			compiler.context.declareDirty(name);
		}
	}
//#line 997 "Parser.java"
//###############################################################
// method: yylexdebug : check lexer state
//###############################################################
void yylexdebug(int state,int ch)
{
String s=null;
  if (ch < 0) ch=0;
  if (ch <= YYMAXTOKEN) //check index bounds
     s = yyname[ch];    //now get it
  if (s==null)
    s = "illegal-symbol";
  debug("state "+state+", reading "+ch+" ("+s+")");
}





//The following are now global, to aid in error reporting
int yyn;       //next next thing to do
int yym;       //
int yystate;   //current parsing state from state table
String yys;    //current token string


//###############################################################
// method: yyparse : parse input and execute indicated items
//###############################################################
int yyparse()
{
boolean doaction;
  init_stacks();
  yynerrs = 0;
  yyerrflag = 0;
  yychar = -1;          //impossible char forces a read
  yystate=0;            //initial state
  state_push(yystate);  //save it
  val_push(yylval);     //save empty value
  while (true) //until parsing is done, either correctly, or w/error
    {
    doaction=true;
    if (yydebug) debug("loop"); 
    //#### NEXT ACTION (from reduction table)
    for (yyn=yydefred[yystate];yyn==0;yyn=yydefred[yystate])
      {
      if (yydebug) debug("yyn:"+yyn+"  state:"+yystate+"  yychar:"+yychar);
      if (yychar < 0)      //we want a char?
        {
        yychar = yylex();  //get next token
        if (yydebug) debug(" next yychar:"+yychar);
        //#### ERROR CHECK ####
        if (yychar < 0)    //it it didn't work/error
          {
          yychar = 0;      //change it to default string (no -1!)
          if (yydebug)
            yylexdebug(yystate,yychar);
          }
        }//yychar<0
      yyn = yysindex[yystate];  //get amount to shift by (shift index)
      if ((yyn != 0) && (yyn += yychar) >= 0 &&
          yyn <= YYTABLESIZE && yycheck[yyn] == yychar)
        {
        if (yydebug)
          debug("state "+yystate+", shifting to state "+yytable[yyn]);
        //#### NEXT STATE ####
        yystate = yytable[yyn];//we are in a new state
        state_push(yystate);   //save it
        val_push(yylval);      //push our lval as the input for next rule
        yychar = -1;           //since we have 'eaten' a token, say we need another
        if (yyerrflag > 0)     //have we recovered an error?
           --yyerrflag;        //give ourselves credit
        doaction=false;        //but don't process yet
        break;   //quit the yyn=0 loop
        }

    yyn = yyrindex[yystate];  //reduce
    if ((yyn !=0 ) && (yyn += yychar) >= 0 &&
            yyn <= YYTABLESIZE && yycheck[yyn] == yychar)
      {   //we reduced!
      if (yydebug) debug("reduce");
      yyn = yytable[yyn];
      doaction=true; //get ready to execute
      break;         //drop down to actions
      }
    else //ERROR RECOVERY
      {
      if (yyerrflag==0)
        {
        yyerror("syntax error");
        yynerrs++;
        }
      if (yyerrflag < 3) //low error count?
        {
        yyerrflag = 3;
        while (true)   //do until break
          {
          if (stateptr<0)   //check for under & overflow here
            {
            yyerror("stack underflow. aborting...");  //note lower case 's'
            return 1;
            }
          yyn = yysindex[state_peek(0)];
          if ((yyn != 0) && (yyn += YYERRCODE) >= 0 &&
                    yyn <= YYTABLESIZE && yycheck[yyn] == YYERRCODE)
            {
            if (yydebug)
              debug("state "+state_peek(0)+", error recovery shifting to state "+yytable[yyn]+" ");
            yystate = yytable[yyn];
            state_push(yystate);
            val_push(yylval);
            doaction=false;
            break;
            }
          else
            {
            if (yydebug)
              debug("error recovery discarding state "+state_peek(0)+" ");
            if (stateptr<0)   //check for under & overflow here
              {
              yyerror("Stack underflow. aborting...");  //capital 'S'
              return 1;
              }
            state_pop();
            val_pop();
            }
          }
        }
      else            //discard this token
        {
        if (yychar == 0)
          return 1; //yyabort
        if (yydebug)
          {
          yys = null;
          if (yychar <= YYMAXTOKEN) yys = yyname[yychar];
          if (yys == null) yys = "illegal-symbol";
          debug("state "+yystate+", error recovery discards token "+yychar+" ("+yys+")");
          }
        yychar = -1;  //read another
        }
      }//end error recovery
    }//yyn=0 loop
    if (!doaction)   //any reason not to proceed?
      continue;      //skip action
    yym = yylen[yyn];          //get count of terminals on rhs
    if (yydebug)
      debug("state "+yystate+", reducing "+yym+" by rule "+yyn+" ("+yyrule[yyn]+")");
    if (yym>0)                 //if count of rhs not 'nil'
      yyval = val_peek(yym-1); //get current semantic value
    yyval = dup_yyval(yyval); //duplicate yyval if ParserVal is used as semantic value
    switch(yyn)
      {
//########## USER-SUPPLIED ACTIONS ##########
case 1:
//#line 29 "parser.y"
{Debug.trace("Parser: Input - empty string matched");}
break;
case 2:
//#line 30 "parser.y"
{Debug.trace("Parser: Input - Stmt Input matched");}
break;
case 3:
//#line 33 "parser.y"
{Debug.trace("Parser: Stmt - Process matched\n");}
break;
case 4:
//#line 34 "parser.y"
{Debug.trace("Parser: Stmt - Declaration matched\n");}
break;
case 5:
//#line 35 "parser.y"
{Debug.trace("Parser: Stmt - Program matched\n");}
break;
case 6:
//#line 36 "parser.y"
{Debug.trace("Parser: Stmt - CSPStmt Matched\n");}
break;
case 7:
//#line 37 "parser.y"
{Debug.trace("Parser: Stmt - Assertion matched\n");}
break;
case 8:
//#line 38 "parser.y"
{Debug.trace("Parser: Stmt - RefDeclaration matched\n");}
break;
case 11:
//#line 46 "parser.y"
{Debug.trace("Parser: CSPStmt - CSP(" + val_peek(0).sval + ") matched"); compiler.csp.add(val_peek(0).sval);}
break;
case 12:
//#line 50 "parser.y"
{
		Debug.trace("Parser: Declaration - INT INameList matched");
		if (val_peek(3).ival > 0)
			declareDirty( (Vector<String>) val_peek(0).obj);
		if (val_peek(1).ival >= 0)
			declareContentSize( (Vector<String>) val_peek(0).obj, val_peek(1).ival);
		/*else < 0 means no size declared*/
	}
break;
case 13:
//#line 59 "parser.y"
{
		Debug.trace("Parser: Declaration - BOOL BNameList matched");
		if (val_peek(2).ival > 0)
			declareDirty( (Vector<String>) val_peek(0).obj);
	}
break;
case 14:
//#line 65 "parser.y"
{
		Debug.trace("Parser: Declaration - INT SizeDeclaration [ArraySizeDeclaration] IANameList matched");
		if (val_peek(6).ival > 0)
			declareDirty( (Vector<String>) val_peek(0).obj);
		if (val_peek(4).ival >= 0)
			declareArrayContentSize( (Vector<String>) val_peek(0).obj, val_peek(4).ival);
		if (val_peek(2).ival >= 0)
			declareArrayIndexSize( (Vector<String>) val_peek(0).obj, val_peek(2).ival);
	}
break;
case 15:
//#line 75 "parser.y"
{
		Debug.trace("Parser: Declaration - BOOL[ArraySizeDeclaration] BANameList matched");
		if (val_peek(5).ival > 0)
			declareDirty( (Vector<String>) val_peek(0).obj);
		if (val_peek(2).ival >= 0)
			declareArrayIndexSize( (Vector<String>) val_peek(0).obj, val_peek(2).ival);
	}
break;
case 16:
//#line 82 "parser.y"
{Debug.trace("Parser: Declaration - SIG[] SigNameList matched");}
break;
case 17:
//#line 83 "parser.y"
{Debug.trace("Parser: Declaration - ISIG[] ISigNameList matched");}
break;
case 18:
//#line 84 "parser.y"
{Debug.trace("Parser: Declaration - GLOBCONST GlobConstList matched");}
break;
case 19:
//#line 88 "parser.y"
{Debug.trace("SizeDeclaration - empty matched"); yyval.ival = -1;}
break;
case 20:
//#line 89 "parser.y"
{Debug.trace("SizeDeclaration - % NUM matched"); yyval.ival = val_peek(0).ival;}
break;
case 21:
//#line 94 "parser.y"
{Debug.trace("ArraySizeDeclaration - empty matched"); yyval.ival = -1;}
break;
case 22:
//#line 95 "parser.y"
{Debug.trace("ArraySizeDeclaration - NUM matched"); yyval.ival = val_peek(0).ival;}
break;
case 23:
//#line 100 "parser.y"
{Debug.trace("DirtyDeclaration - empty matched"); yyval.ival = -1;}
break;
case 24:
//#line 101 "parser.y"
{Debug.trace("DirtyDeclaration - DIRTY matched"); yyval.ival = 1;}
break;
case 25:
//#line 105 "parser.y"
{Vector<String>v = new Vector<String>(); v.add(val_peek(0).sval); yyval.obj = v;Debug.trace("Parser: INameList - IName matched");}
break;
case 26:
//#line 106 "parser.y"
{Vector<String> v = (Vector<String>)val_peek(0).obj; v.add(val_peek(2).sval); yyval.obj = v;Debug.trace("Parser: INameList - IName , INameList matched");}
break;
case 27:
//#line 109 "parser.y"
{compiler.context.newI(val_peek(0).sval);yyval.sval = val_peek(0).sval;Debug.trace("Parser: IName - NAME (" + val_peek(0).sval + ") matched");}
break;
case 28:
//#line 110 "parser.y"
{compiler.context.newI(val_peek(2).sval, val_peek(0).ival);yyval.sval = val_peek(2).sval;Debug.trace("Parser: IName - NAME (" + val_peek(2).sval + ") = NUM ("+ val_peek(0).ival + ") matched");}
break;
case 29:
//#line 114 "parser.y"
{Vector<String>v = new Vector<String>(); v.add(val_peek(0).sval); yyval.obj = v;Debug.trace("Parser: BNameList - BName matched");}
break;
case 30:
//#line 115 "parser.y"
{Vector<String> v = (Vector<String>)val_peek(0).obj; v.add(val_peek(2).sval); yyval.obj = v;Debug.trace("Parser: BNameList - BName), BNameList matched");}
break;
case 31:
//#line 118 "parser.y"
{compiler.context.newB(val_peek(0).sval);yyval.sval = val_peek(0).sval;Debug.trace("Parser: BName - NAME (" + val_peek(0).sval + ") matched");}
break;
case 32:
//#line 119 "parser.y"
{compiler.context.newB(val_peek(2).sval, true);yyval.sval = val_peek(2).sval;Debug.trace("Parser: BNameList - NAME (" + val_peek(2).sval + ") = TRUE matched");}
break;
case 33:
//#line 120 "parser.y"
{compiler.context.newB(val_peek(2).sval, false);yyval.sval = val_peek(2).sval;Debug.trace("Parser: BNameList - NAME (" + val_peek(2).sval + ") = FALSE matched");}
break;
case 34:
//#line 125 "parser.y"
{Vector<String>v = new Vector<String>(); v.add(val_peek(0).sval); yyval.obj = v;Debug.trace("Parser: IANameList - IAName matched");}
break;
case 35:
//#line 126 "parser.y"
{Vector<String> v = (Vector<String>)val_peek(0).obj; v.add(val_peek(2).sval); yyval.obj = v;Debug.trace("Parser: IANameList - IAName , IANameList matched");}
break;
case 36:
//#line 129 "parser.y"
{compiler.context.newIA(val_peek(0).sval);yyval.sval = val_peek(0).sval;Debug.trace("Parser: IAName - NAME (" + val_peek(0).sval + ") matched");}
break;
case 37:
//#line 130 "parser.y"
{compiler.context.newIA(val_peek(4).sval, (Vector<Integer>)val_peek(1).obj);yyval.sval = val_peek(4).sval;Debug.trace("Parser: IAName - NAME (" + val_peek(4).sval + ") = < NonEmptyNumList > matched");}
break;
case 38:
//#line 134 "parser.y"
{Vector<String>v = new Vector<String>(); v.add(val_peek(0).sval); yyval.obj = v; Debug.trace("Parser: BANameList - BAName matched");}
break;
case 39:
//#line 135 "parser.y"
{Vector<String> v = (Vector<String>)val_peek(0).obj; v.add(val_peek(2).sval); yyval.obj = v; Debug.trace("Parser: BANameList - BAName (" + val_peek(2).sval + "), BANameList matched");}
break;
case 40:
//#line 138 "parser.y"
{compiler.context.newGlobConst(val_peek(2).sval, val_peek(0).ival); Debug.trace("Parser: GlobConstList - NAME(" + val_peek(2).sval + " = " + "NUM(" + val_peek(0).ival + ") - matched");}
break;
case 41:
//#line 139 "parser.y"
{compiler.context.newGlobConst(val_peek(4).sval, val_peek(2).ival); Debug.trace("Parser: GlobConstList - NAME(" + val_peek(4).sval + " = " + "NUM(" + val_peek(2).ival + ") , GlobConstList - matched");}
break;
case 42:
//#line 142 "parser.y"
{compiler.context.newBA(val_peek(0).sval);yyval.sval = val_peek(0).sval;Debug.trace("Parser: BAName - NAME (" + val_peek(0).sval + ") matched");}
break;
case 43:
//#line 143 "parser.y"
{compiler.context.newBA(val_peek(4).sval, (Vector<Boolean>)val_peek(1).obj);yyval.sval = val_peek(4).sval; Debug.trace("Parser: BAName - NAME(" + val_peek(4).sval + ") = < NonEmptyBoolList >");}
break;
case 44:
//#line 146 "parser.y"
{Vector<Boolean> vector = new Vector<Boolean>(); vector.add(true); yyval.obj = vector; Debug.trace("Parser: NonEmptyBoolList - TRUE matched");}
break;
case 45:
//#line 147 "parser.y"
{((Vector<Boolean>)val_peek(2).obj).add(true); yyval.obj = val_peek(2).obj; Debug.trace("Parser: NonEmptyBoolList - NonEmptyBoolList, TRUE matched");}
break;
case 46:
//#line 148 "parser.y"
{Vector<Boolean> vector = new Vector<Boolean>(); vector.add(false); yyval.obj = vector; Debug.trace("Parser: NonEmptyBoolList - FALSE matched");}
break;
case 47:
//#line 149 "parser.y"
{((Vector<Boolean>)val_peek(2).obj).add(false); yyval.obj = val_peek(2).obj; Debug.trace("Parser: NonEmptyBoolList - NonEmptyBoolList, FALSE matched");}
break;
case 48:
//#line 152 "parser.y"
{compiler.context.newSig(val_peek(1).sval,val_peek(0).ival);Debug.trace("Parser: SigNameList - NAME (" + val_peek(1).sval + ") matched");}
break;
case 49:
//#line 153 "parser.y"
{compiler.context.newSig(val_peek(3).sval,val_peek(2).ival);Debug.trace("Parser: SigNameList - NAME (" + val_peek(3).sval + "), SigNameList matched");}
break;
case 50:
//#line 156 "parser.y"
{compiler.context.newISig(val_peek(1).sval,val_peek(0).ival);Debug.trace("Parser: ISigNameList - NAME (" + val_peek(1).sval + ") matched");}
break;
case 51:
//#line 157 "parser.y"
{compiler.context.newISig(val_peek(3).sval,val_peek(2).ival);Debug.trace("Parser: ISigNameList - NAME (" + val_peek(3).sval + "), ISigNameList matched");}
break;
case 52:
//#line 160 "parser.y"
{yyval.ival = 0;}
break;
case 53:
//#line 161 "parser.y"
{yyval.ival = val_peek(0).ival;}
break;
case 54:
//#line 164 "parser.y"
{yyval.ival = 1;}
break;
case 55:
//#line 165 "parser.y"
{yyval.ival = val_peek(0).ival + 1;}
break;
case 56:
//#line 169 "parser.y"
{Debug.trace("Parser: CompilationCommand empty matched"); yyval.sval = "StructuredCompile";}
break;
case 57:
//#line 170 "parser.y"
{Debug.trace("Parser: CompilationCommand LEAFCOMPRESSED matched"); yyval.sval = "LeafCompressedStructuredCompile";}
break;
case 58:
//#line 171 "parser.y"
{Debug.trace("Parser: CompilationCommand HIERARCHCOMPRESSED matched"); yyval.sval = "HierarchCompressedCompile";}
break;
case 59:
//#line 175 "parser.y"
{
						Debug.trace("Parser: Program - NAME(" + val_peek(3).sval + ") = CompilationCommand CmdStruct matched");
						CmdStruct CS = ((PreCmdStruct) val_peek(0).obj).generate(compiler, new TreeMap<String,Integer>());
						compiler.progs.put(val_peek(3).sval,new CmdStructProgram( val_peek(3).sval,CS, val_peek(1).sval));
						compiler.context.newProgram(val_peek(3).sval);
				 	}
break;
case 60:
//#line 197 "parser.y"
{
			yyval.obj = new PreCSLeaf(val_peek(3).sval, (Vector<ProcessParameter>) val_peek(1).obj);
			Debug.trace("Parser: CmdStruct - PROCESS '(' ParameterList ')' matched");
		}
break;
case 61:
//#line 202 "parser.y"
{
			yyval.obj = new PreCSOverseer(val_peek(3).sval, (Vector<ProcessParameter>) val_peek(1).obj);
			Debug.trace("Parser: CmdStruct - OVERSEER PROCESS '(' ParameterList ')' matched");
		}
break;
case 62:
//#line 207 "parser.y"
{
			Vector<PreCmdStruct> vec = (Vector<PreCmdStruct>) val_peek(1).obj;
			yyval.obj = new PreCSNode(vec);
			Debug.trace("Parser: CmdStruct - < CmdStructList > matched");
		}
break;
case 63:
//#line 213 "parser.y"
{
			yyval.obj = new PreCSParamaterisedNode((Vector<PreCmdStruct>)val_peek(7).obj, val_peek(5).sval, (ProcessParameter)val_peek(3).obj, (ProcessParameter)val_peek(1).obj);
		
			Debug.trace("Parser: CmdStruct -  '<' CmdStructList '|' NAME FROM Parameter TO Parameter '>'  matched");
		}
break;
case 64:
//#line 222 "parser.y"
{ 
					Vector<PreCmdStruct> vec = new Vector<PreCmdStruct>();
					vec.add( (PreCmdStruct) val_peek(0).obj);
					yyval.obj = vec;
					Debug.trace("Parser: CmdStructList - CmdStruct matched");
				}
break;
case 65:
//#line 229 "parser.y"
{
					Vector<PreCmdStruct> vec = (Vector<PreCmdStruct>)val_peek(2).obj;
					vec.add( (PreCmdStruct) val_peek(0).obj);
					yyval.obj = vec;
					Debug.trace("Parser: CmdStructList - CmdStructList , CmdStruct matched");
				}
break;
case 66:
//#line 238 "parser.y"
{ Debug.trace("Parser: ParameterList - empty matched"); yyval.obj = new Vector<ProcessParameter>(); }
break;
case 67:
//#line 239 "parser.y"
{ Debug.trace("Parser: ParameterList - NonEmptyParameterList matched"); yyval.obj = val_peek(0).obj; }
break;
case 68:
//#line 244 "parser.y"
{ 	Debug.trace("Parser: NonEmptyParameterList - Parameter matched"); 
			Vector<ProcessParameter> vec = new Vector<ProcessParameter>(); 
			vec.add((ProcessParameter) val_peek(0).obj);
			yyval.obj = vec;
		}
break;
case 69:
//#line 250 "parser.y"
{ 	Debug.trace("Parser: NonEmptyParameterList - Parameter ',' NonEmptyParameterList matched"); 
			Vector<ProcessParameter> vec = (Vector<ProcessParameter>) val_peek(2).obj; 
			vec.add((ProcessParameter) val_peek(0).obj);
			yyval.obj = vec;
		}
break;
case 70:
//#line 258 "parser.y"
{ yyval.obj = new ConstParam(val_peek(0).sval); Debug.trace("Parser: Parameter - CONST (" + val_peek(0).sval + ") matched");}
break;
case 71:
//#line 259 "parser.y"
{ yyval.obj = new NameParam(val_peek(0).sval); Debug.trace("Parser: Parameter - NAME (" + val_peek(0).sval + ") matched");}
break;
case 72:
//#line 260 "parser.y"
{ yyval.obj = new NumParam(val_peek(0).ival); Debug.trace("Parser: Parameter -  NUM (" + val_peek(0).ival + ") matched");}
break;
case 73:
//#line 262 "parser.y"
{ 	yyval.obj = new AddParam( (ProcessParameter)val_peek(2).obj, (ProcessParameter) val_peek(0).obj); 
			Debug.trace("Parser: Parameter - Parameter + Parameter matched");}
break;
case 74:
//#line 265 "parser.y"
{ 	yyval.obj = new SubParam( (ProcessParameter)val_peek(2).obj, (ProcessParameter) val_peek(0).obj); 
			Debug.trace("Parser: Parameter - Parameter - Parameter matched");}
break;
case 75:
//#line 268 "parser.y"
{ 	yyval.obj = new MultParam((ProcessParameter)val_peek(2).obj, (ProcessParameter) val_peek(0).obj); 
			Debug.trace("Parser: Parameter - Parameter * Parameter matched");}
break;
case 76:
//#line 271 "parser.y"
{ 	yyval.obj = new DivParam( (ProcessParameter)val_peek(2).obj, (ProcessParameter) val_peek(0).obj);
			Debug.trace("Parser: Parameter - Parameter / Parameter matched");}
break;
case 77:
//#line 274 "parser.y"
{ 	yyval.obj = new ModParam( (ProcessParameter)val_peek(2).obj, (ProcessParameter) val_peek(0).obj); 
			Debug.trace("Parser: Parameter - Parameter % Parameter matched");}
break;
case 78:
//#line 277 "parser.y"
{ yyval.obj = new NegParam((ProcessParameter)val_peek(0).obj); Debug.trace("Parser: Parameter - -Parameter matched");}
break;
case 79:
//#line 278 "parser.y"
{ yyval.obj = val_peek(1).obj; Debug.trace ("Parameter - (Parameter) matched");}
break;
case 80:
//#line 282 "parser.y"
{
		assert  val_peek(1).obj instanceof Vector :  "Proc - PROCESS(NonEmptyNumList) $3.obj incorrect type";
		
		Process process = compiler.procs.get(val_peek(3).sval);
		Vector<Integer> args = (Vector<Integer>)val_peek(1).obj;
		if (process.numArgs() != args.size()) throw new ParserException(val_peek(3).sval + " given " + args.size() + " arguments but expects " + process.numArgs());
		
		yyval.obj = new InitializedProc(process, args);
		Debug.trace("Parser: Proc - PROCESS ( NonEmptyNumList ) matched");
	}
break;
case 81:
//#line 293 "parser.y"
{
		Process process = compiler.procs.get(val_peek(2).sval);
		/*trace("process = " + process);*/
		
		if (process.numArgs() != 0) throw new ParserException(val_peek(2).sval + " given no arguments but expects " + process.numArgs());
		
		yyval.obj = new InitializedProc(process, new Vector<Integer>());
		Debug.trace("Parser: Proc - PROCESS () matched");
		/*trace("Proc - returning " + $$.obj);*/
	}
break;
case 82:
//#line 306 "parser.y"
{
				Vector<Integer> vector = new Vector<Integer>();
				vector.add(val_peek(0).ival);
				yyval.obj = vector;
				Debug.trace("Parser: NonEmptyNumList - NUM(" + val_peek(0).ival + ") matched");
				/*trace("NonEmptyNumList returning " + $$.obj);*/
			}
break;
case 83:
//#line 314 "parser.y"
{	
				assert  val_peek(2).obj instanceof Vector :  "NonEmptyNumList - NonEmptyNumList, Num $1.obj incorrect type";
				((Vector<Integer>)val_peek(2).obj).add(val_peek(0).ival); 
				yyval.obj = val_peek(2).obj; 
				Debug.trace("Parser: NonEmptyNumList - NonEmptyNumList, NUM(" + val_peek(0).ival + ") mathced");
				/*trace("NonEmptyNumList returning " + $$.obj);*/
			}
break;
case 84:
//#line 323 "parser.y"
{compiler.context.registerConstants((Vector<String>)val_peek(1).obj); currentProcess = val_peek(3).sval; Debug.trace("Parser: Registering Constants for " + val_peek(3).sval);}
break;
case 85:
//#line 323 "parser.y"
{ 	
				Process proc =  new Process(val_peek(7).sval, (Vector<String>)val_peek(5).obj, (Cmd)val_peek(1).obj, (VariableAssignment)val_peek(0).obj) ;
				proc.addLocalIVars(compiler.context.getLocalIVars());
				proc.addLocalBVars(compiler.context.getLocalBVars());
				proc.addLocalIAVars(compiler.context.getLocalIAVars());
				proc.addLocalBAVars(compiler.context.getLocalBAVars());
				compiler.procs.put(val_peek(7).sval,proc);
				compiler.context.newProcess(val_peek(7).sval);
				Debug.trace("Parser: Process - NAME(" + val_peek(7).sval + ") (ArgList) = Prog matched");
				compiler.context.deregisterConstsAndLocals();/*needs doing before next arglist is found*/
							    /*as lexer should flag names in arglist as names not consts	*/
			}
break;
case 86:
//#line 337 "parser.y"
{yyval.obj = new Vector<String>(); Debug.trace("Parser: ArgList - Empty String matched\n");}
break;
case 87:
//#line 338 "parser.y"
{yyval.obj = val_peek(0).obj;Debug.trace("Parser: ArgList - NonEmptyArgList matched\n");}
break;
case 88:
//#line 341 "parser.y"
{Vector<String> v = new Vector<String>(); v.add(val_peek(0).sval); yyval.obj = v;Debug.trace("Parser: NonEmptyArgList - Name(" + val_peek(0).sval + ") matched");}
break;
case 89:
//#line 342 "parser.y"
{ ((Vector<String>)val_peek(2).obj).add(val_peek(0).sval); yyval.obj = val_peek(2).obj;Debug.trace("Parser: NonEmptyArgList - Name(" + val_peek(2).sval + "), NonEmptyArgList matched");}
break;
case 90:
//#line 346 "parser.y"
{yyval.obj = val_peek(0).obj;Debug.trace("Parser: Prog - Cmd matched");}
break;
case 91:
//#line 347 "parser.y"
{yyval.obj = val_peek(1).obj;Debug.trace("Parser: Prog - { Cmds } matched");}
break;
case 92:
//#line 350 "parser.y"
{yyval.obj = val_peek(0).obj; Debug.trace("Parser: Cmds - Cmd matched");}
break;
case 93:
//#line 351 "parser.y"
{yyval.obj = val_peek(1).obj; Debug.trace("Parser: Cmds - Cmd ; matched");}
break;
case 94:
//#line 352 "parser.y"
{yyval.obj = new Seq( (Cmd)val_peek(2).obj, (Cmd)val_peek(0).obj); Debug.trace("Parser: Cmds - Cmd;Cmd matched\n");}
break;
case 95:
//#line 353 "parser.y"
{yyval.obj = val_peek(0).obj; Debug.trace("Parser: Cmds -  INT LocalINameList ; matched\n");}
break;
case 96:
//#line 354 "parser.y"
{yyval.obj = val_peek(0).obj; Debug.trace("Parser: Cmds -  INT [ ] LocalIANameList ; matched\n");}
break;
case 97:
//#line 355 "parser.y"
{yyval.obj = val_peek(0).obj; Debug.trace("Parser: Cmds -  BOOL LocalBNameList ; matched\n");}
break;
case 98:
//#line 356 "parser.y"
{yyval.obj = val_peek(0).obj; Debug.trace("Parser: Cmds - BOOL [ ] LocalBANameList ; matched\n");}
break;
case 99:
//#line 359 "parser.y"
{yyval.obj = new Skip(); Debug.trace("Parser: Cmd - Skip matched\n");}
break;
case 100:
//#line 360 "parser.y"
{yyval.obj = new Iter( (Cmd) val_peek(0).obj); Debug.trace("Parser: Cmd - ITER Prog matched\n");}
break;
case 101:
//#line 361 "parser.y"
{yyval.obj = new While( (BExpr) val_peek(2).obj, (Cmd) val_peek(0).obj); Debug.trace("Parser: Cmd - WHILE BExpr DO Prog matched\n");}
break;
case 102:
//#line 363 "parser.y"
{yyval.obj = new If( (BExpr) val_peek(2).obj, (Cmd) val_peek(0).obj); Debug.trace("Parser: Cmd - IF BExpr THEN Prog matched\n");}
break;
case 103:
//#line 364 "parser.y"
{yyval.obj = new If( (BExpr) val_peek(4).obj, (Cmd) val_peek(2).obj, (Cmd) val_peek(0).obj); Debug.trace("Parser: Cmd - IF BExpr THEN Prog Else Prog matched\n");}
break;
case 104:
//#line 365 "parser.y"
{yyval.obj = new IAssign( (IExpr) val_peek(2).obj, (IExpr) val_peek(0).obj); Debug.trace("Parser: Cmd - IVName ASSIGN IExpr matched\n");}
break;
case 105:
//#line 366 "parser.y"
{yyval.obj = new BAssign( (BExpr) val_peek(2).obj, (BExpr) val_peek(0).obj); Debug.trace("Parser: Cmd - BVName ASSIGN BExpr matched\n");}
break;
case 106:
//#line 367 "parser.y"
{yyval.obj = new Sig(val_peek(2).sval, (Vector<IConst>)val_peek(1).obj); Debug.trace("Parser: Cmd - Sig(" + val_peek(2).sval + " Indices)  matched\n");}
break;
case 107:
//#line 368 "parser.y"
{yyval.obj = new ISig(val_peek(4).sval, (Vector<IConst>)val_peek(3).obj, (IExpr) val_peek(1).obj); Debug.trace("Parser: Cmd - ISig(" + val_peek(4).sval + " Indices, IEXpr)  matched\n");}
break;
case 108:
//#line 369 "parser.y"
{yyval.obj = new Atomic((Cmd)val_peek(0).obj); Debug.trace("Parser: Cmd - Atomic Prog matched\n");}
break;
case 109:
//#line 371 "parser.y"
{ Debug.trace("Parser: Cmd - PROCESS '(' IConstList ')' matched\n");
			Process macro = compiler.procs.get(val_peek(3).sval);
			Vector<IConst> args = (Vector<IConst>) val_peek(1).obj;
			if (macro.numArgs() != args.size()) throw new ParserException(val_peek(3).sval + " given " + args.size() + " arguments but expects " + macro.numArgs());
			yyval.obj = macro.prog.substituteConst(macro.consts, args) ;
			for (String name : macro.getLocalIVars())
				compiler.context.newLocalI(name);
			for (String name : macro.getLocalBVars())
				compiler.context.newLocalB(name);
			for (String name : macro.getLocalIAVars())
				compiler.context.newLocalIA(name);
			for (String name : macro.getLocalBAVars())
				compiler.context.newLocalBA(name);
		}
break;
case 110:
//#line 388 "parser.y"
{Debug.trace("Parser: IConstList - Empty matched"); yyval.obj = new Vector<IConst>();}
break;
case 111:
//#line 389 "parser.y"
{Debug.trace("Parser: IConstList - NonEmptyIConstList matched"); yyval.obj = val_peek(0).obj;}
break;
case 112:
//#line 392 "parser.y"
{	Debug.trace("Parser: NonEmptyIConstList - IConst matched"); 
								Vector<IConst> vec = new Vector<IConst>();
								vec.add((IConst) val_peek(0).obj);
								yyval.obj = vec;}
break;
case 113:
//#line 396 "parser.y"
{	Debug.trace("Parser: NonEmptyIConstList - NonEmptyIConstList ',' IConst matched"); 
								Vector<IConst> vec = (Vector<IConst>)val_peek(2).obj;
								vec.add((IConst) val_peek(0).obj);
								yyval.obj = vec;}
break;
case 114:
//#line 402 "parser.y"
{Vector<String>v = new Vector<String>(); v.add(val_peek(0).sval); yyval.obj = v;Debug.trace("Parser: LocalINameList - LocalIName matched");}
break;
case 115:
//#line 403 "parser.y"
{Vector<String> v = (Vector<String>)val_peek(0).obj; v.add(val_peek(2).sval); yyval.obj = v;Debug.trace("Parser: LocalINameList - LocalIName , LocalINameList matched");}
break;
case 116:
//#line 406 "parser.y"
{Vector<String>v = new Vector<String>(); v.add(val_peek(0).sval); yyval.obj = v;Debug.trace("Parser: LocalBNameList - LocalBName matched");}
break;
case 117:
//#line 407 "parser.y"
{Vector<String> v = (Vector<String>)val_peek(0).obj; v.add(val_peek(2).sval); yyval.obj = v;Debug.trace("Parser: LocalBNameList - LocalBName , LocalBNameList matched");}
break;
case 118:
//#line 411 "parser.y"
{Vector<String>v = new Vector<String>(); v.add(val_peek(0).sval); yyval.obj = v;Debug.trace("Parser: LocalIANameList - LocalIAName matched");}
break;
case 119:
//#line 412 "parser.y"
{Vector<String> v = (Vector<String>)val_peek(0).obj; v.add(val_peek(2).sval); yyval.obj = v;Debug.trace("Parser: LocalIANameList - LocalIAName , LocalIANameList matched");}
break;
case 120:
//#line 415 "parser.y"
{Vector<String>v = new Vector<String>(); v.add(val_peek(0).sval); yyval.obj = v;Debug.trace("Parser: LocalBANameList - LocalBAName matched");}
break;
case 121:
//#line 416 "parser.y"
{Vector<String> v = (Vector<String>)val_peek(0).obj; v.add(val_peek(2).sval); yyval.obj = v;Debug.trace("Parser: LocalBANameList - LocalBAName , LocalBANameList matched");}
break;
case 122:
//#line 419 "parser.y"
{compiler.context.newLocalI(val_peek(0).sval);yyval.sval = val_peek(0).sval;Debug.trace("Parser: LocalIName - NAME (" + val_peek(0).sval + ") matched");}
break;
case 123:
//#line 421 "parser.y"
{compiler.context.newLocalB(val_peek(0).sval);yyval.sval = val_peek(0).sval;Debug.trace("Parser: LocalBName - NAME (" + val_peek(0).sval + ") matched");}
break;
case 124:
//#line 423 "parser.y"
{compiler.context.newLocalIA(val_peek(0).sval);yyval.sval = val_peek(0).sval;Debug.trace("Parser: LocalIAName - NAME (" + val_peek(0).sval + ") matched");}
break;
case 125:
//#line 425 "parser.y"
{compiler.context.newLocalBA(val_peek(0).sval);yyval.sval = val_peek(0).sval;Debug.trace("Parser: LocalBAName - NAME (" + val_peek(0).sval + ") matched");}
break;
case 126:
//#line 428 "parser.y"
{ yyval.obj = new Vector<IConst>(); Debug.trace("Parser: Indices - Empty matched");}
break;
case 127:
//#line 429 "parser.y"
{ Vector<IConst> vec = (Vector<IConst>) val_peek(2).obj; vec.add((IConst) val_peek(0).obj); yyval.obj = vec;}
break;
case 128:
//#line 441 "parser.y"
{yyval.obj = new VariableAssignment(); Debug.trace("Parser: AssignedVariables - Empty matched");}
break;
case 129:
//#line 442 "parser.y"
{ yyval.obj = val_peek(1).obj; Debug.trace("Parser: AssignedVariables - WITH '{' AssignedVariableList '}' matched");}
break;
case 130:
//#line 446 "parser.y"
{VariableAssignment va = new VariableAssignment(); va.is.add(val_peek(0).sval); yyval.obj = va; Debug.trace("Parser: AssignedVariableList - IVAR matched");}
break;
case 131:
//#line 447 "parser.y"
{VariableAssignment va = new VariableAssignment(); va.bs.add(val_peek(0).sval); yyval.obj = va; Debug.trace("Parser: AssignedVariableList - BVAR matched");}
break;
case 132:
//#line 448 "parser.y"
{VariableAssignment va = new VariableAssignment(); va.ias.add(val_peek(0).sval); yyval.obj = va; Debug.trace("Parser: AssignedVariableList - IAVAR matched");}
break;
case 133:
//#line 449 "parser.y"
{VariableAssignment va = new VariableAssignment(); va.bas.add(val_peek(0).sval); yyval.obj = va; Debug.trace("Parser: AssignedVariableList - BAVAR matched");}
break;
case 134:
//#line 450 "parser.y"
{VariableAssignment va = new VariableAssignment(); va.iaAccesses.add(new Access(val_peek(3).sval,(IConst)val_peek(1).obj)); yyval.obj = va; Debug.trace("Parser: AssignedVariableList - IAVAR '[' IConst ']' matched");}
break;
case 135:
//#line 451 "parser.y"
{VariableAssignment va = new VariableAssignment(); va.baAccesses.add(new Access(val_peek(3).sval,(IConst)val_peek(1).obj)); yyval.obj = va; Debug.trace("Parser: AssignedVariableList - BAVAR '[' IConst ']' matched");}
break;
case 136:
//#line 452 "parser.y"
{VariableAssignment va = (VariableAssignment)val_peek(2).obj; va.is.add(val_peek(0).sval); yyval.obj = va; Debug.trace("Parser: AssignedVariableList - AssignedVariableList ',' IVAR  matched");}
break;
case 137:
//#line 453 "parser.y"
{VariableAssignment va = (VariableAssignment)val_peek(2).obj; va.bs.add(val_peek(0).sval); yyval.obj = va; Debug.trace("Parser: AssignedVariableList - AssignedVariableList ',' BVAR  matched");}
break;
case 138:
//#line 454 "parser.y"
{VariableAssignment va = (VariableAssignment)val_peek(2).obj; va.ias.add(val_peek(0).sval); yyval.obj = va; Debug.trace("Parser: AssignedVariableList - AssignedVariableList ',' IAVAR  matched");}
break;
case 139:
//#line 455 "parser.y"
{VariableAssignment va = (VariableAssignment)val_peek(2).obj; va.bas.add(val_peek(0).sval); yyval.obj = va; Debug.trace("Parser: AssignedVariableList - AssignedVariableList ',' BAVAR  matched");}
break;
case 140:
//#line 456 "parser.y"
{VariableAssignment va = (VariableAssignment)val_peek(5).obj; va.iaAccesses.add(new Access(val_peek(3).sval,(IConst)val_peek(1).obj)); yyval.obj = va; Debug.trace("Parser: AssignedVariableList - AssignedVariableList ',' IAVAR '[' IConst ']' matched");}
break;
case 141:
//#line 457 "parser.y"
{VariableAssignment va = (VariableAssignment)val_peek(5).obj; va.baAccesses.add(new Access(val_peek(3).sval,(IConst)val_peek(1).obj)); yyval.obj = va; Debug.trace("Parser: AssignedVariableList - AssignedVariableList ',' BAVAR '[' IConst ']' matched");}
break;
case 142:
//#line 460 "parser.y"
{ yyval.obj = new VarIConst(val_peek(0).sval); Debug.trace("Parser: IConst - CONST (" + val_peek(0).sval + ") matched");}
break;
case 143:
//#line 461 "parser.y"
{ yyval.obj = new NumIConst(val_peek(0).ival); Debug.trace("Parser: IConst -  NUM (" + val_peek(0).ival + ") matched");}
break;
case 144:
//#line 462 "parser.y"
{ yyval.obj = new AddConst( (IConst)val_peek(2).obj, (IConst) val_peek(0).obj); Debug.trace("Parser: IConst - IConst + IConst matched");}
break;
case 145:
//#line 463 "parser.y"
{ yyval.obj = new SubConst( (IConst)val_peek(2).obj, (IConst) val_peek(0).obj); Debug.trace("Parser: IConst - IConst - IConst matched");}
break;
case 146:
//#line 464 "parser.y"
{ yyval.obj = new MultConst((IConst)val_peek(2).obj, (IConst) val_peek(0).obj); Debug.trace("Parser: IConst - IConst * IConst matched");}
break;
case 147:
//#line 465 "parser.y"
{ yyval.obj = new DivConst( (IConst)val_peek(2).obj, (IConst) val_peek(0).obj); Debug.trace("Parser: IConst - IConst / IConst matched");}
break;
case 148:
//#line 466 "parser.y"
{ yyval.obj = new ModConst( (IConst)val_peek(2).obj, (IConst) val_peek(0).obj); Debug.trace("Parser: IConst - IConst % IConst matched");}
break;
case 149:
//#line 467 "parser.y"
{ yyval.obj = new NegIConst((IConst)val_peek(0).obj); Debug.trace("Parser: IConst - -IConst matched");}
break;
case 150:
//#line 468 "parser.y"
{ yyval.obj = val_peek(1).obj; Debug.trace ("IConst - (IConst) matched");}
break;
case 151:
//#line 471 "parser.y"
{yyval.obj = new Not( (BExpr) val_peek(0).obj); Debug.trace("Parser: BExpr -  !BExpr matched");}
break;
case 152:
//#line 472 "parser.y"
{yyval.obj = new And( (BExpr) val_peek(2).obj, (BExpr) val_peek(0).obj);Debug.trace("Parser: BExpr - BExpr AND BExpr matched");}
break;
case 153:
//#line 473 "parser.y"
{yyval.obj = new Or( (BExpr) val_peek(2).obj, (BExpr) val_peek(0).obj);Debug.trace("Parser: BExpr - BExpr OR BExpr matched");}
break;
case 154:
//#line 474 "parser.y"
{yyval.obj = new Eq( (IExpr) val_peek(2).obj, (IExpr) val_peek(0).obj); Debug.trace("Parser: BExpr - IExpr = IExpr matched");}
break;
case 155:
//#line 475 "parser.y"
{yyval.obj = new Neq( (IExpr) val_peek(2).obj, (IExpr) val_peek(0).obj); Debug.trace("Parser: BExpr - IExpr NEQ IExpr matched");}
break;
case 156:
//#line 476 "parser.y"
{yyval.obj = new Ge( (IExpr) val_peek(2).obj, (IExpr) val_peek(0).obj); Debug.trace("Parser: BExpr - IExpr GE IExpr matched");}
break;
case 157:
//#line 477 "parser.y"
{yyval.obj = new Gt( (IExpr) val_peek(2).obj, (IExpr) val_peek(0).obj); Debug.trace("Parser: BExpr - IExpr > IExpr matched");}
break;
case 158:
//#line 478 "parser.y"
{yyval.obj = new Le( (IExpr) val_peek(2).obj, (IExpr) val_peek(0).obj);  Debug.trace("Parser: BExpr - IExpr LE IExpr matched");}
break;
case 159:
//#line 479 "parser.y"
{yyval.obj = new Lt( (IExpr) val_peek(2).obj, (IExpr) val_peek(0).obj);  Debug.trace("Parser: BExpr - IExpr < IExpr matched");}
break;
case 160:
//#line 480 "parser.y"
{yyval.obj = val_peek(1).obj;  Debug.trace("Parser: BExpr - (BExpr) matched");}
break;
case 161:
//#line 481 "parser.y"
{yyval.obj = new True();  Debug.trace("Parser: BExpr - TRUE matched");}
break;
case 162:
//#line 482 "parser.y"
{yyval.obj = new False(); Debug.trace("Parser: BExpr - FALSE matched");}
break;
case 163:
//#line 483 "parser.y"
{yyval.obj = val_peek(0).obj; Debug.trace("Parser: BExpr - BVar matched");}
break;
case 164:
//#line 486 "parser.y"
{ yyval.obj = new BVar(val_peek(0).sval);  Debug.trace("Parser: BVar - BVAR("+val_peek(0).sval+") matched");}
break;
case 165:
//#line 487 "parser.y"
{ yyval.obj = new BArray(val_peek(3).sval, (IExpr) val_peek(1).obj);Debug.trace("Parser: BVar - BVAR("+val_peek(3).sval+") [IConst]  matched");}
break;
case 166:
//#line 488 "parser.y"
{ yyval.obj = new LocalBVar(val_peek(0).sval,currentProcess);Debug.trace("Parser: BVar - LOCALBVAR("+val_peek(0).sval+") matched");}
break;
case 167:
//#line 489 "parser.y"
{ yyval.obj = new LocalBArray(val_peek(3).sval,currentProcess,(IExpr) val_peek(1).obj);Debug.trace("Parser: BVar - LOCALBAVAR("+val_peek(3).sval+") '[' IExpr ']' matched");}
break;
case 168:
//#line 492 "parser.y"
{yyval.obj = new Plus( (IExpr) val_peek(2).obj, (IExpr) val_peek(0).obj);Debug.trace("Parser: IExpr - IExpr + IExpr matched");}
break;
case 169:
//#line 493 "parser.y"
{yyval.obj = new Minus( (IExpr) val_peek(2).obj, (IExpr) val_peek(0).obj);Debug.trace("Parser: IExpr - IExpr - IExpr matched");}
break;
case 170:
//#line 494 "parser.y"
{yyval.obj = new Times( (IExpr) val_peek(2).obj, (IExpr) val_peek(0).obj);Debug.trace("Parser: IExpr - IExpr * IExpr matched");}
break;
case 171:
//#line 495 "parser.y"
{yyval.obj = new Div( (IExpr) val_peek(2).obj, (IExpr) val_peek(0).obj);Debug.trace("Parser: IExpr - IExpr / IExpr matched");}
break;
case 172:
//#line 496 "parser.y"
{yyval.obj = new Mod( (IExpr) val_peek(2).obj, (IExpr) val_peek(0).obj);Debug.trace("Parser: IExpr - IExpr % IExpr matched");}
break;
case 173:
//#line 497 "parser.y"
{yyval.obj = new Max( (IExpr)val_peek(3).obj, (IExpr)val_peek(1).obj); Debug.trace("Parser: IExpr - MAX ( IExpr, IExpr) matched");}
break;
case 174:
//#line 498 "parser.y"
{yyval.obj = new Min( (IExpr)val_peek(3).obj, (IExpr)val_peek(1).obj); Debug.trace("Parser: IExpr - MIN ( IExpr, IExpr) matched");}
break;
case 175:
//#line 499 "parser.y"
{yyval.obj = new Neg( (IExpr) val_peek(0).obj);Debug.trace("Parser: IExpr - -IExpr matched");}
break;
case 176:
//#line 500 "parser.y"
{yyval.obj = val_peek(1).obj; Debug.trace("Parser: IExpr - (IExpr) matched");}
break;
case 177:
//#line 501 "parser.y"
{ yyval.obj = new IConstExpr(new VarIConst(val_peek(0).sval)); Debug.trace("Parser: IExpr - CONST (" + val_peek(0).sval + ") matched");}
break;
case 178:
//#line 502 "parser.y"
{ yyval.obj = new IConstExpr(new NumIConst(val_peek(0).ival)); Debug.trace("Parser: IExpr -  NUM (" + val_peek(0).ival + ") matched");}
break;
case 179:
//#line 503 "parser.y"
{yyval.obj = val_peek(0).obj;Debug.trace("Parser: IExpr - IVar matched");}
break;
case 180:
//#line 506 "parser.y"
{ yyval.obj = new IVar(val_peek(0).sval);Debug.trace("Parser: IVar - IVAR("+val_peek(0).sval+") matched");}
break;
case 181:
//#line 507 "parser.y"
{ yyval.obj = new IArray(val_peek(3).sval, (IExpr) val_peek(1).obj);Debug.trace("Parser: IVar - IVAR("+val_peek(3).sval+") [IConst]  matched");}
break;
case 182:
//#line 508 "parser.y"
{ yyval.obj = new LocalIVar(val_peek(0).sval,currentProcess);Debug.trace("Parser: IVar - LOCALIVAR("+val_peek(0).sval+") matched");}
break;
case 183:
//#line 509 "parser.y"
{ yyval.obj = new LocalIArray(val_peek(3).sval,currentProcess,(IExpr) val_peek(1).obj);Debug.trace("Parser: IVar - LOCALIAVAR("+val_peek(3).sval+") '[' IExpr ']' matched");}
break;
case 184:
//#line 513 "parser.y"
{ 
			compiler.asserts.add(new BoolAssertion(compiler.progs.get(val_peek(0).sval),(BExpr)val_peek(2).obj));
			Debug.trace("Parser: Assertion - ASSERT ALWAYS BExpr IN PROGRAM(" + val_peek(0).sval + ") matched");
		}
break;
case 185:
//#line 518 "parser.y"
{ 
			compiler.asserts.add(new BoolAssertion(compiler.progs.get(val_peek(0).sval),new Not((BExpr)val_peek(2).obj)));
			Debug.trace("Parser: Assertion - ASSERT NEVER BExpr IN PROGRAM(" + val_peek(0).sval + ") matched");
		}
break;
case 186:
//#line 523 "parser.y"
{
			compiler.asserts.add(new SignalAssertion(compiler.progs.get(val_peek(0).sval), (Vector<String>)val_peek(3).obj));
			Debug.trace("Parser: Assertion - ASSERT NOSIGNAL { SignalList } IN PROGRAM(" + val_peek(0).sval + ")"); 
		}
break;
case 187:
//#line 528 "parser.y"
{
			compiler.asserts.add(new CSPAssertion(val_peek(2).sval,compiler.progs.get(val_peek(0).sval)));
			Debug.trace("Parser: Assertion - ASSERT CSPASSERT IN PROGRAM(" + val_peek(0).sval + ")");
		}
break;
case 188:
//#line 533 "parser.y"
{
			compiler.asserts.add(new SeqRefinementAssertion((CompilableProc)val_peek(2).obj,(CompilableProc)val_peek(0).obj));
			Debug.trace("Parser: Assertion - ASSERT Proc SEQREFINEMENT Proc (" + val_peek(0).sval + ")");
		
		}
break;
case 189:
//#line 539 "parser.y"
{
			compiler.asserts.add(new GenRefinementAssertion((CompilableProc)val_peek(2).obj,(CompilableProc)val_peek(0).obj));
			Debug.trace("Parser: Assertion - ASSERT Proc GENREFINEMENT Proc (" + val_peek(0).sval + ")");
		
		}
break;
case 190:
//#line 545 "parser.y"
{
			compiler.asserts.add(new ParRefinementAssertion((CmdStructProgram)val_peek(2).obj,(CmdStructProgram)val_peek(0).obj));
			Debug.trace("Parser: Assertion - ASSERT ParRefTerm PARREFINEMENT ParRefTerm (" + val_peek(0).sval + ")");
		
		}
break;
case 191:
//#line 553 "parser.y"
{yyval.obj = new CmdStructProgram(val_peek(0).obj.toString(), new CSLeaf( (CompilableProc)val_peek(0).obj)); Debug.trace("Parser: ParRefTerm - Proc matched");}
break;
case 192:
//#line 554 "parser.y"
{yyval.obj = compiler.progs.get(val_peek(0).sval); Debug.trace("Parser: ParRefTerm - PROGRAM matched");}
break;
case 193:
//#line 557 "parser.y"
{Vector<String> vec = new Vector<String>(); vec.add(val_peek(0).sval); yyval.obj = vec; Debug.trace("Parser: SignalList - Signal(" + val_peek(0).sval + ") matched");}
break;
case 194:
//#line 558 "parser.y"
{((Vector<String>)val_peek(0).obj).add(val_peek(2).sval); yyval.obj = val_peek(0).obj; Debug.trace("Parser: SignalList - Signal(" + val_peek(2).sval + ") , SignalList matched");}
break;
case 195:
//#line 561 "parser.y"
{yyval.sval = val_peek(0).sval; Debug.trace("Parser: Signal - SIGNAME(" + val_peek(0).sval + ") matched");}
break;
case 196:
//#line 562 "parser.y"
{yyval.sval = val_peek(2).sval + "." + String.valueOf(val_peek(0).ival); Debug.trace("Parser: Signal - ISIGNAME(" + val_peek(2).sval + ") . NUM(" + String.valueOf(val_peek(0).ival));}
break;
case 197:
//#line 564 "parser.y"
{yyval.sval = "error"; Debug.trace("Parser: Signal - ERROR matched");}
break;
case 198:
//#line 565 "parser.y"
{yyval.sval = "verror"; Debug.trace("Parser: Signal - VERROR matched");}
break;
case 199:
//#line 569 "parser.y"
{compiler.context.setParReads((Vector<String>)val_peek(1).obj); Debug.trace("Parser: RefDeclaration - PARREADS '{' VarNameList '}' matched");}
break;
case 200:
//#line 570 "parser.y"
{compiler.context.setParWrites((Vector<String>)val_peek(1).obj); Debug.trace("Parser: RefDeclaration - PARWRITES '{' VarNameList '}' matched");}
break;
case 201:
//#line 571 "parser.y"
{compiler.context.setSeqReads((Vector<String>)val_peek(1).obj); Debug.trace("Parser: RefDeclaration - SEQREADS '{' VarNameList '}' matched");}
break;
case 202:
//#line 572 "parser.y"
{compiler.context.setSeqWrites((Vector<String>)val_peek(1).obj); Debug.trace("Parser: RefDeclaration - SEQWRITES '{' VarNameList '}' matched");}
break;
case 203:
//#line 576 "parser.y"
{yyval.obj = new Vector<String>(); Debug.trace("Parser: VarNameList - Empty List matched");}
break;
case 204:
//#line 577 "parser.y"
{yyval.obj = val_peek(0).obj; Debug.trace("Parser: VarNameList - Empty List matched");}
break;
case 205:
//#line 581 "parser.y"
{Vector<String> vec = (Vector<String>)val_peek(2).obj; vec.add(val_peek(0).sval); yyval.obj = vec; Debug.trace("Parser: NonEmptyVarNameList - NonEmptyVarNameList ',' VarName matched");}
break;
case 206:
//#line 582 "parser.y"
{Vector<String> vec = new Vector<String>(); vec.add(val_peek(0).sval); yyval.obj = vec; Debug.trace("Parser: NonEmptyVarNameList - VarName matched");}
break;
case 207:
//#line 586 "parser.y"
{yyval.sval = val_peek(0).sval; Debug.trace("Parser: VarName - IVAR matched");}
break;
case 208:
//#line 587 "parser.y"
{yyval.sval = val_peek(0).sval; Debug.trace("Parser: VarName - BVAR matched");}
break;
case 209:
//#line 588 "parser.y"
{yyval.sval = val_peek(0).sval; Debug.trace("Parser: VarName - IAVAR matched");}
break;
case 210:
//#line 589 "parser.y"
{yyval.sval = val_peek(0).sval; Debug.trace("Parser: VarName - BAVAR matched");}
break;
case 211:
//#line 590 "parser.y"
{yyval.sval = val_peek(3).sval + "[" + val_peek(1).ival + "]"; Debug.trace("Parser: VarName - IAVAR '[' NUM ']' matched");}
break;
case 212:
//#line 591 "parser.y"
{yyval.sval = val_peek(3).sval + "[" + val_peek(1).ival + "]"; Debug.trace("Parser: VarName - BAVAR matched");}
break;
//#line 2137 "Parser.java"
//########## END OF USER-SUPPLIED ACTIONS ##########
    }//switch
    //#### Now let's reduce... ####
    if (yydebug) debug("reduce");
    state_drop(yym);             //we just reduced yylen states
    yystate = state_peek(0);     //get new state
    val_drop(yym);               //corresponding value drop
    yym = yylhs[yyn];            //select next TERMINAL(on lhs)
    if (yystate == 0 && yym == 0)//done? 'rest' state and at first TERMINAL
      {
      if (yydebug) debug("After reduction, shifting from state 0 to state "+YYFINAL+"");
      yystate = YYFINAL;         //explicitly say we're done
      state_push(YYFINAL);       //and save it
      val_push(yyval);           //also save the semantic value of parsing
      if (yychar < 0)            //we want another character?
        {
        yychar = yylex();        //get next character
        if (yychar<0) yychar=0;  //clean, if necessary
        if (yydebug)
          yylexdebug(yystate,yychar);
        }
      if (yychar == 0)          //Good exit (if lex returns 0 ;-)
         break;                 //quit the loop--all DONE
      }//if yystate
    else                        //else not done yet
      {                         //get next state and push, for next yydefred[]
      yyn = yygindex[yym];      //find out where to go
      if ((yyn != 0) && (yyn += yystate) >= 0 &&
            yyn <= YYTABLESIZE && yycheck[yyn] == yystate)
        yystate = yytable[yyn]; //get new state
      else
        yystate = yydgoto[yym]; //else go to new defred
      if (yydebug) debug("after reduction, shifting from state "+state_peek(0)+" to state "+yystate+"");
      state_push(yystate);     //going again, so push state & val...
      val_push(yyval);         //for next action
      }
    }//main loop
  return 0;//yyaccept!!
}
//## end of method parse() ######################################



//## run() --- for Thread #######################################
/**
 * A default run method, used for operating this parser
 * object in the background.  It is intended for extending Thread
 * or implementing Runnable.  Turn off with -Jnorun .
 */
public void run()
{
  yyparse();
}
//## end of method run() ########################################



//## Constructors ###############################################
/**
 * Default constructor.  Turn off with -Jnoconstruct .

 */
public Parser()
{
  //nothing to do
}


/**
 * Create a parser, setting the debug to true or false.
 * @param debugMe true for debugging, false for no debug.
 */
public Parser(boolean debugMe)
{
  yydebug=debugMe;
}
//###############################################################



}
//################### END OF CLASS ##############################
