%%


%byaccj
%line
%column

%{
  private Parser yyparser;
  
  //final boolean DEBUG = false;// true;
  Context context;
  //int lineno = 0;
  public Yylex(java.io.Reader r, Parser yyparser, Context context) {
    this(r);
    this.yyparser = yyparser;
    this.context = context;
  }

 /* private void trace(String s)
  {
	if (DEBUG)
		System.out.println("Lexer: " + s);
  }*/

  public String location() { return "Line " + (yyline + 1) + " Column " + yycolumn; } 
%}

NUM = [0-9]+
LETTER = [A-Za-z]
NAME = {LETTER}({LETTER}|[0-9])*
NL  = \r|\n|\r\n|\u2028|\u2029|\u000B|\u000C|\u0085
COMMENT = "//".*
CSP = "%%".*
CSPASSERT = "%-".*"-%"

%%


"[G="  {Debug.trace("Lexer: GENREFINEMENT"); return Parser.GENREFINEMENT;} 
"[S="  {Debug.trace("Lexer: SEQREFINEMENT"); return Parser.SEQREFINEMENT;} 
"[P="  {Debug.trace("Lexer: PARREFINEMENT"); return Parser.PARREFINEMENT;} 

":=" {Debug.trace("Lexer: ASSIGN");return Parser.ASSIGN; }

/* operators */
"+" | "-" | "*" | "/" | "%" | "<" | ">" |"[" | "]" | 
"{" | "}" | "(" | ")" | "!" | "," | "=" | ";"| "." | ":"
   { Debug.trace("Lexer: " + yytext());return (int) yycharat(0); }

"!=" {Debug.trace("Lexer: NE");return Parser.NEQ; }
">=" {Debug.trace("Lexer: GE");return Parser.GE; }
"<=" {Debug.trace("Lexer: LE");return Parser.LE; }
"&&" {Debug.trace("Lexer: AND");return Parser.AND; }
"||" {Debug.trace("Lexer: OR");return Parser.OR; }
"|" {Debug.trace("Lexer: |");return (int) yycharat(0); }
"from" {Debug.trace("Lexer: TRUE");return Parser.FROM;}
"to" {Debug.trace("Lexer: TRUE");return Parser.TO;}
"true" {Debug.trace("Lexer: TRUE");return Parser.TRUE;}
"false" {Debug.trace("Lexer: FALSE");return Parser.FALSE;}

"skip" {Debug.trace("Lexer: SKIP");return Parser.SKIP; }
"iter" {Debug.trace("Lexer: ITER");return Parser.ITER; }
"while" {Debug.trace("Lexer: WHILE");return Parser.WHILE; }
"do" {Debug.trace("Lexer: DO");return Parser.DO; }
"if" {Debug.trace("Lexer: IF");return Parser.IF; }
"then" {Debug.trace("Lexer: THEN");return Parser.THEN; }
"else" {Debug.trace("Lexer: ELSE");return Parser.ELSE; }
"sig" {Debug.trace("Lexer: SIG");return Parser.SIG; }
"isig" {Debug.trace("Lexer: ISIG");return Parser.ISIG; }
"atomic" {Debug.trace("Lexer: ATOMIC");return Parser.ATOMIC; }
"int" {Debug.trace("Lexer: INT");return Parser.INT; }
"bool" {Debug.trace("Lexer: BOOL"); return Parser.BOOL; }
"assert" {Debug.trace("Lexer: ASSERT"); return Parser.ASSERT;}
"in" {Debug.trace("Lexer: IN"); return Parser.IN;}
"always" {Debug.trace("Lexer: ALWAYS"); return Parser.ALWAYS;}
"never" {Debug.trace("Lexer: NEVER"); return Parser.NEVER;}
//"outofrange" {Debug.trace("Lexer: OUTOFRANGE"); return Parser.OUTOFRANGE;}
"error" {Debug.trace("Lexer: ERROR"); return Parser.ERROR;}
"verror" {Debug.trace("Lexer: VERROR"); return Parser.VERROR;}
"nosignal" {Debug.trace("Lexer: NOSIGNAL"); return Parser.NOSIGNAL;}
"max"	{Debug.trace("Lexer: MAX"); return Parser.MAX;}
"min"	{Debug.trace("Lexer: MIN"); return Parser.MIN;}
"const" {Debug.trace("Lexer: GLOBCONST"); return Parser.GLOBCONST;}
"ParReads" {Debug.trace("Lexer: PARREADS"); return Parser.PARREADS;}
"ParWrites" {Debug.trace("Lexer: PARWRITES"); return Parser.PARWRITES;}
"SeqReads" {Debug.trace("Lexer: SEQREADS"); return Parser.SEQREADS;}
"SeqWrites" {Debug.trace("Lexer: SEQWRITES"); return Parser.SEQWRITES;}
// "local" {Debug.trace("Lexer: LOCAL"); return Parser.LOCAL;}
//"idle"  {Debug.trace("Lexer: NOOP"); return Parser.NOOP;}
"with"	{Debug.trace("Lexer: WITH"); return Parser.WITH;}
//"watching" {Debug.trace("Lexer: WATCHING"); return Parser.WATCHING;}
"dirty" {Debug.trace("Lexer: DIRTY"); return Parser.DIRTY;}
"leafCompress" {Debug.trace("Lexer: LEAFCOMPRESSED"); return Parser.LEAFCOMPRESSED;}
"hierarchCompress" {Debug.trace("Lexer: HIERARCHCOMPRESSED"); return Parser.HIERARCHCOMPRESSED;}
"overseer" {Debug.trace("Lexer: OVERSEER"); return Parser.OVERSEER;}
{ NAME }
{ 
	String name = yytext();
	yyparser.yylval = new ParserVal(name);
	if (context.isI(name))
		{Debug.trace("Lexer: IVAR(" + name+")");return Parser.IVAR;}
	else if (context.isB(name))
		{Debug.trace("Lexer: BVAR(" + name+")");return Parser.BVAR;}
	else if (context.isIA(name))
		{Debug.trace("Lexer: IAVAR(" + name+")");return Parser.IAVAR;}
	else if (context.isBA(name))
		{Debug.trace("Lexer: BAVAR(" + name+")");return Parser.BAVAR;}
	else if (context.isConstant(name))
		{Debug.trace("Lexer: CONST(" + name +")"); return Parser.CONST;}
	else if (context.isLocalI(name))
		{Debug.trace("Lexer: LOCALIVAR(" + name +")"); return Parser.LOCALIVAR;}
	else if (context.isLocalB(name))
		{Debug.trace("Lexer: LOCALBVAR(" + name +")"); return Parser.LOCALBVAR;}
	else if (context.isLocalIA(name))
		{Debug.trace("Lexer: LOCALIAVAR(" + name +")"); return Parser.LOCALIAVAR;}
	else if (context.isLocalBA(name))
		{Debug.trace("Lexer: LOCALBAVAR(" + name +")"); return Parser.LOCALBAVAR;}
	else if (context.isSig(name))
		{Debug.trace("Lexer: SIGNAME(" + name +")"); return Parser.SIGNAME;}
	else if (context.isISig(name))
		{Debug.trace("Lexer: ISIGNAME(" + name +")"); return Parser.ISIGNAME;}
	else if (context.isProcess(name))
		{Debug.trace("Lexer: PROCESS(" + name +")"); return Parser.PROCESS;}
	else if (context.isProgram(name))
		{Debug.trace("Lexer: PROGRAM(" + name +")"); return Parser.PROGRAM;}
	else {Debug.trace("Lexer: NAME(" + name+")");return Parser.NAME;}

}

{NUM}  { yyparser.yylval = new ParserVal(Integer.parseInt(yytext()));
	 Debug.trace("Lexer: NUM(" + yytext() + ")");
         return Parser.NUM; }

/* whitespace and comments*/
([\t]|" "|{COMMENT}|{NL})+ {}

//{NL} {Debug.trace("Lexer: NEW LINE!");lineno++;}

{CSP} { yyparser.yylval = new ParserVal(yytext().substring(2)); Debug.trace("Lexer: CSP: "+ yytext()); return Parser.CSP; }
{CSPASSERT} { String text = yytext(); text = text.substring(2,text.length()-2); yyparser.yylval = new ParserVal(text); Debug.trace("Lexer: CSPASSERT: "+ text); return Parser.CSPASSERT; }

/* error fallback */
[^]    { System.err.println("Error: unexpected character '"+yytext()+"' near " + location()); return -1; }
