import org.junit.*;
import static org.junit.Assert.*;
import static org.junit.matchers.JUnitMatchers.*;


import java.io.*;
import java.util.*;

public class MergeTraceConstructorTest
{
	@Test
	public void extAtomicExampleMergesProperly() throws java.io.IOException
	{
		Context context = new Context();
		context.newI("x");
		context.newI("y");
	
		MergeTraceConstructor mtc = new MergeTraceConstructor();
		
		Vector<TraceEvent> actual = mtc.constructTrace(new DummyAssert(), 
		new BufferedReader(new StringReader(
		//"Checking output.csp\n" + 
		//"\n" + 
		//"Checking compress(GenRefTest(fst(PP()))) [T= GenRefTest(fst(QQ()))\n" + 
		//"xfalse\n" + 
		"BEGIN TRACE example=0 process=1 path=0\n" + 
		"PStart\n" + 
		"_tau\n" + 
		"_tau\n" + 
		"start_at.-1\n" + 
		"iveval.-1.IV.2.1\n" + 
		"iveval.-1.IV.1.1\n" + 
		"END TRACE example=0 process=1 path=0\n" + 
		"BEGIN TRACE example=0 process=1 path=0 0\n" + 
		"PStart\n" + 
		"_tau\n" + 
		"_tau\n" + 
		"start_at.-1\n" + 
		"iveval.-1.IV.2.1\n" + 
		"iveval.-1.IV.1.1\n" + 
		"END TRACE example=0 process=1 path=0 0\n" + 
		"BEGIN TRACE example=0 process=1 path=0 0 0\n" + 
		"PStart\n" + 
		"ivwrite.0.IV.1.1\n" + 
		"ivwrite.0.IV.2.1\n" + 
		"start_at.-1\n" + 
		"iveval.-1.IV.2.1\n" + 
		"iveval.-1.IV.1.1\n" + 
		"END TRACE example=0 process=1 path=0 0 0\n" + 
		"BEGIN ALLOWS\n" + 
		"PStart\n" + 
		"ivwrite.0.IV.1.1\n" + 
		"ivwrite.0.IV.2.1\n" + 
		"start_at.-1\n" + 
		"END ALLOWS\n" + 
		"BEGIN ALLOWS\n" + 
		"PStart\n" + 
		"ivwrite.0.IV.1.1\n" + 
		"ivwrite.0.IV.2.1\n" + 
		"END ALLOWS\n" + 
		"BEGIN ALLOWS\n" + 
		"PStart\n" + 
		"start_at.-1\n" + 
		"END ALLOWS\n" + 
		"BEGIN TRACE example=0 process=1 path=0 0 0 1\n" + 
		"ivwrite.0.IV.1.1\n" + 
		"ivwrite.0.IV.2.1\n" + 
		"start_at.-1\n" + 
		"iveval.-1.IV.2.1\n" + 
		"iveval.-1.IV.1.1\n" + 
		"END TRACE example=0 process=1 path=0 0 0 1\n" + 
		"BEGIN ALLOWS\n" + 
		"ivwrite.0.IV.2.1\n" + 
		"start_at.-1\n" + 
		"iveval.-1.IV.2.1\n" + 
		"END ALLOWS\n" + 
		"BEGIN ALLOWS\n" + 
		"ivwrite.0.IV.2.1\n" + 
		"start_at.-1\n" + 
		"iveval.-1.IV.2.1\n" + 
		"END ALLOWS\n" + 
		"BEGIN ALLOWS\n" + 
		"\n" + 
		"END ALLOWS\n" + 
		"BEGIN TRACE example=0 process=1 path=0 0 0 1 1\n" + 
		"ivwrite.0.IV.1.1\n" + 
		"start_at.-1\n" + 
		"iveval.-1.IV.1.1\n" + 
		"END TRACE example=0 process=1 path=0 0 0 1 1\n" + 
		"BEGIN TRACE example=0 process=1 path=0 0 0 1 1 0\n" + 
		"ivwrite.0.IV.1.1\n" + 
		"start_at.-1\n" + 
		"iveval.-1.IV.1.1\n" + 
		"END TRACE example=0 process=1 path=0 0 0 1 1 0\n" + 
		"BEGIN ALLOWS\n" + 
		"\n" + 
		"END ALLOWS\n" + 
		"BEGIN TRACE example=0 process=1 path=0 1\n" + 
		"PStart\n" + 
		"start_at.-1\n" + 
		"iveval.-1.IV.2.1\n" + 
		"iveval.-1.IV.1.1\n" + 
		"END TRACE example=0 process=1 path=0 1\n" + 
		"\n" + 
		"Checking compress(GenRefTest(fst(QQ()))) [T= GenRefTest(fst(PP()))\n" + 
		"true\n"
		)),context);

		Vector<TraceEvent> expected = new Vector<TraceEvent>();
		expected.add(new PStart());
		expected.add(new IVarWrite(0,"x",1));
		expected.add(new IVarWrite(0,"y",1));
		expected.add(new StartAt(-1));
		expected.add(new IVarRead(-1,"y",1));
		expected.add(new IVarRead(-1,"x",1));
		
		
		assertEquals(expected,actual);
	}




}